/*******************************************************************/
/*******************************************************************/
/*                                                                 */
/*         CLASS GROUP AND REGULATOR (McCURLEY, BUCHMANN)          */
/*                    GENERAL NUMBER FIELDS                        */
/*                                                                 */
/*******************************************************************/
/*******************************************************************/
/* $Id: buch2.c,v 1.914.7.1 1997/01/19 16:18:09 karim Exp karim $ */
#include "genpari.h"
#include "nf.h"

GEN compute_class_number(GEN mit,GEN *met,GEN *u1,GEN *u2);

static long CBUCHG; /* de la forme 2^k-1 */

static GEN buchall_for_degree_one_pol(GEN P,long flun);
static GEN subfactorbasegen(long N,long m,GEN vectbase,long minsfb,long *vperm,long *ptss);
static GEN **powsubfactgen(GEN nf,GEN w,long a,long PRECREG,long PRECREGINT);
static GEN idealmulprimeredall(GEN nf,GEN x,GEN vp,long PRECREG,long PRECREGINT);
static GEN getfu(GEN nf,GEN *ptxarch,GEN reg,long flun,long *pte,long PRECREG);
static GEN cleancol(GEN x,long N,long RU,long PRECREG);
static GEN quad_form(GEN *cbase,GEN ma,GEN ideal,long PRECREG);

static GEN compute_regulator(GEN mit,long col,GEN matarch,long RU,long R1,long N,long PRECREG,GEN *xarch,GEN *xreal,GEN *image_mdet,long *ptsreg);

static GEN compute_check(GEN mit,long col,GEN image_mdet,GEN xreal,long RU,GEN *reg,GEN z,GEN zu,GEN clh,long PRECREG,GEN *parch);

static GEN class_group_generators(long PRECREG,long PRECREGINT,GEN nf,GEN met,GEN clh,GEN u1,GEN u2,GEN vectbase,long *vperm);

static long factorisegen(GEN nf,GEN ideal,long kcz,long limp,long *primfact,long *expoprimfact, long *primfactorbase,GEN *idealbase,long *numideal, long *numprimfactorbase);

static GEN compute_matt2(long RU,GEN nf,long *nbmatt2);

static long factorisealpha(GEN nf,GEN alpha,long kcz,long limp,long *primfact,long *expoprimfact,long *primfactorbase,GEN *idealbase,long *numideal,long *numprimfactorbase);

static long factorbasegen(GEN nf,long n2,long n,long **ptnumprim,long **ptprim,long **ptnum,GEN **ptideal,long *ptkc,long *ptkcz,long *ptkcz2,GEN *ptlfun);

static long small_norm_for_buchall(long s,long **mat,GEN matarch,long KC,long KCCO,long KCZ,long LIMC,long N,GEN D,long RU,long R1,long PRECREG,GEN nf,GEN vectbase,long *prim,GEN *idealbase,long *numideal,long *numprim,GEN IDN,GEN gborne,long nbrelpid,GEN INVP,long *L);

static long random_relation(long t,long q,long LIMC,long KC,long KCZ,long RU,long PRECREG,long PRECREGINT,GEN nf,long *firstime,long *secondtime,long *iz, long *jideal,long *bouext,long *bou,long *slim,long **ptvinvperm,long lgsub,GEN *idealbase,long *numideal,long *prim,long *numprim, long *vperm,long *subvperm,long **mat,GEN matarch,long **matcopy, GEN lmatt2,long nbmatt2,long *ex,GEN IDN,GEN **vp,long nlze,long *phase,long *extrarel,long *cmptglob,long *nbtest,GEN *extramat,GEN *extramatc);

static long already_found_relation_of_long (long **mat,long s,long KC);

static void desallocate(GEN primsubfactorbase,long cmptglob,GEN **vp,long *numprim,long *prim,long *numideal,GEN *idealbase,long *ex,long **matcopy,long *vperm,long *subvperm,long *vinvperm,long flvp,long phase);

static long be_honest(long KCZ,long KCZ2,long RU,long PRECREGINT,GEN IDN,long s,GEN nf,long lgsub,GEN *idealbase,long *numideal,long *prim,long *numprim,long q,GEN **vp,long *ex,GEN exu);

static GEN relationrank(long **mat,long KC,long s,long *L);
static long addcolumntomatrix(long KC,long t,long *primfact,long *expoprimfact,GEN *INVP,long *L);

#define MAXRELSUP (min(50,4*KC))

static long
cgcd(long a,long b)
{
  while (b) { long r=a%b; a=b; b=r; }
  return a;
}

static long
ccontent(long* x,long n)
{
  long i, s=labs(x[1]);
  for (i=2; i<=n && s>1; i++) s=cgcd(labs(x[i]),s);
  return s;
}

GEN
buchall(GEN P,GEN gcbach,GEN gcbach2,GEN gRELSUP,GEN gborne,long nbrelpid,
        long minsfb,long flun,long prec)
{
  long av,av0,av1,av2,tetpil,i,j,k,ss,lgsub,n1,*p1,*ex,q,s,nbtest,resuhonest,c;
  long N,R1,R2,RU,CO,PRECREG,PRECREGINT,LIMC,LIMC2,lim,KC,KC2,KCZ,KCZ2,KCCO,KCCOPRO;
  long ip,extrarel,iz,ncz,col,k0,nlze,sreg,colnew,bou,bouext,cmptglob,limpile;
  long **mat,**matcopy,*vperm,*vinvperm,*subvperm;
  long *numprim,*prim,*numideal,nrelsup,nreldep,phase,sfact,slim,jideal;
  long firstime,secondtime,nbmatt2,flT2,flvp,flHONEST,flnf;
  double cbach,cbach2,drc,LOGD,rootdisc;
  GEN pgen1,pgen2,pgen3,matgenpro,lmatt2,**vp,*idealbase,matarch,exu,fu,zu;
  GEN nf,D,primsubfactorbase,vectbase,xarch,xreal,met,mit,reg,lfun,z,clh;
  GEN matalpha,u1,u2,RES,extramat,extramatc,c_1,image_mdet,pdep,parch,IDN;
  GEN clgg,clg1,clg2;
  GEN *gptr[4];

  long *liste;
  GEN invp;

  if (DEBUGLEVEL) timer2();
  if (typ(P)!=t_POL)
  {
    if (typ(P)!=t_VEC || lg(P)!=10) err(talker,"incorrect object in buchxxx");
    nf=P; P=(GEN)nf[1]; flnf=1;
  }
  else flnf=0;
  if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  N=lgef(P)-3; if (N<=1) return buchall_for_degree_one_pol(P,flun);
  av=avma; pgen1=factor(P); pgen2=(GEN)pgen1[1]; pgen3=(GEN)pgen1[2];
  if (lg(pgen2)>2 || cmpis((GEN)pgen3[1],1)>0) err(bucher10);
  avma=av;
  if (DEBUGLEVEL)
  {
    fprintferr("temps trivialites: "); fprintferr("%ld\n",timer2());
    flusherr();
  }
FORCEFU:

/* Initialisations */

  if (typ(gRELSUP)!=t_INT) gRELSUP=gtrunc(gRELSUP);
  if (gsigne(gRELSUP)<=0) err(bucher5);
  IDN=idmat(N);
  if (!flnf)
  {
    nf=initalgall0(P,flun>=0? nf_REGULAR: nf_DIFFERENT,max(8,prec));
    if (DEBUGLEVEL)
    {
      fprintferr("temps initalg: "); fprintferr("%ld\n",timer2());
      flusherr();
      if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    }
  }
  if (labs(flun)>1) 
    RES = cgetg(11,t_VEC);
  else
    RES = flun ? cgetg(9,t_VEC) : cgetg(8,t_VEC);
  RES[1]=nf[1]; RES[2]=nf[2];
  pgen1=cgetg(3,t_VEC); pgen1[1]=nf[3]; pgen1[2]=nf[4];
  RES[3]=(long)pgen1;
  RES[4]=nf[7];

  R1=itos(gmael(nf,2,1)); R2=(N-R1)/2; RU=R1+R2; D=(GEN)nf[3];
  zu=rootsof1(nf);
  CO=itos(gRELSUP)+RU-1;
  drc=gtodouble(D); LOGD=log(fabs(drc));
  lim=max((long)(exp(-(N+0.))*sqrt(2*PI*N*fabs(drc))*pow(4/PI,R2+0.)),3);
  cbach=gtodouble(gcbach); cbach2=gtodouble(gcbach2); rootdisc=exp(LOGD/N);
  if (DEBUGLEVEL)
  {
    fprintferr("temps rootsof1 et/ou trivialites: ");
    fprintferr("%ld\n",timer2()); flusherr();
  }
  av0=avma;
INCREASEGEN:
  if (DEBUGLEVEL) fprintferr("cbach = %f\n",cbach);
  nreldep=nrelsup=0; LIMC=max(20,(long)(cbach*LOGD*LOGD));
  LIMC2=max(3*N,(long)(cbach2*LOGD*LOGD));
  if (LIMC>LIMC2) LIMC2=LIMC;

/* Calcul de la factor-base, de la sub-factor-base et initialisation de vperm */

  if (DEBUGLEVEL)
  {
    fprintferr("\n N = %ld , R1 = %ld , R2 = %ld , RU = %ld",N,R1,R2,RU);
    fprintferr("\n D^(1/N) = %f",rootdisc);
    fprintferr(" , LIMC = %ld , LIMC2 = %ld\n",LIMC,LIMC2);
    fprintferr(" D = "); outerr(D); flusherr();
  }
  KC2=factorbasegen(nf,LIMC2,LIMC,&numprim,&prim,&numideal,&idealbase,
		    &KC,&KCZ,&KCZ2,&lfun);
  if (!KC)
  {
    free(numprim); free(prim); free(numideal); free(idealbase);
    avma=av0; cbach=2*cbach; cbach2=max(cbach2,cbach); goto INCREASEGEN;
  }

  if (DEBUGLEVEL)
  {
    fprintferr("temps creation de la factor base: ");
    fprintferr("%ld\n",timer2()); flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }

    if (DEBUGLEVEL>6)
    { 
      for (i=1; i<=KCZ; i++)
	{ fprintferr("++ idealbase[%ld] = ",i); outerr(idealbase[i]); }
    }

    if (DEBUGLEVEL>7)
    {
      fprintferr("########## FACTORBASE ##########\n\n");
      fprintferr("KC2 = %ld , KC = %ld , KCZ = %ld , KCZ2 = %ld\n",
                 KC2,KC,KCZ,KCZ2);
      for (i=1; i<=KCZ; i++)
	{ fprintferr("++ idealbase[%ld] = ",i); outerr(idealbase[i]); }
    }
  }

  vectbase=cgetg(KC+1,t_COL);
  for (i=1; i<=KCZ; i++)
  {
    ip=numideal[prim[i]]; pgen1=idealbase[i]; n1=lg(pgen1);
    for (j=1; j<n1; j++) vectbase[ip+j]=pgen1[j];
  }
  z=gmul(gmul(gmul(gpuigs(gdeux,-R1),gpuigs(gmul2n(mppi(DEFAULTPREC),1),-R2)),
	      gsqrt(gabs(D,0),DEFAULTPREC)),lfun);
  vperm=(long*)xmalloc(sizeof(long)*(KC+1)); for (i=1; i<=KC; i++) vperm[i]=i;
  primsubfactorbase=subfactorbasegen(N,min(lim,LIMC2),vectbase,minsfb,vperm,&ss);
  lgsub=lg(primsubfactorbase);
  if (DEBUGLEVEL)
  {
    fprintferr("temps creation de la sous-factor base: ");
    fprintferr("%ld\n",timer2()); flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }

    if (DEBUGLEVEL>3)
    {
      fprintferr("\n***** LISTE DES IDEAUX DE LA FACTEUR BASE *****\n\n");
      for (i=1; i<=KC; i++)
	{ fprintferr("no %ld = ",i); outerr((GEN)vectbase[i]); }
      fprintferr("\n***** LISTE DES IDEAUX DE LA SOUS-FACTEUR BASE *****\n\n");
      outerr(primsubfactorbase);
      fprintferr("\n***** PERMUTATION D'ORIGINE *****\n\n");
      for (i=1; i<=KC; i++) fprintferr("vperm[%ld] = %ld\n",i,vperm[i]);
      fprintferr("\n"); flusherr();
    }
  }
  if (ss==-1)
  {
    free(vperm); free(numprim); free(prim); free(numideal); free(idealbase);
    avma=av0; cbach=2*cbach; cbach2=max(cbach2,cbach);
    goto INCREASEGEN;
  }

 /* Calcule la precision, cree matarch, affecte les relations triviales */

  PRECREGINT=((gexpo(D)*(lgsub-2)+((N*N)>>2))>>TWOPOTBITS_IN_LONG)+4;
  PRECREG=max(prec+1,PRECREGINT); CBUCHG=15; KCCO=KC+RU-1+max(ss,itos(gRELSUP));
  if (DEBUGLEVEL) fprintferr("sous-factor base a %ld elements\n",lgsub-1);
  if (DEBUGLEVEL)
  {
    fprintferr("\nCO = %ld , nbrelsup = %ld , ss = %ld , ",CO,itos(gRELSUP),ss);
    fprintferr("KCZ = %ld , KC = %ld , KCCO = %ld \n",KCZ,KC,KCCO);
    flusherr();
  }
  subvperm=(long*)xmalloc(sizeof(long)*lgsub);
  for (i=1; i<lgsub; i++) subvperm[i]=vperm[i];
  ex=(long*)xmalloc(lgsub<<TWOPOTBYTES_IN_LONG); exu=cgetg(RU+1,t_VEC);
  q=BITS_IN_RANDOM-1-(long)ceil(log((double)CBUCHG)/log(2.0)); s=0;
  mat=(long**)xmalloc(sizeof(long*)*(KCCO+1)); matarch=cgetg(KCCO+1,t_MAT);
  for (i=1; i<=KCCO; i++)
  {
    p1=(long *)xmalloc(sizeof(long)*(KC+1)); mat[i]=p1;
    for (j=1; j<=KC; j++) p1[j]=0;
    pgen1=cgetg(RU+1,t_COL); matarch[i]=(long)pgen1;
    for (j=1; j<=RU; j++)
    {
      pgen2=cgetg(3,t_COMPLEX); pgen1[j]=(long)pgen2;
      pgen2[1]=lgetr(PRECREG); pgen2[2]=lgetr(PRECREG);
    }
  }
  for (i=1; i<=KCZ; i++)
  {
    ip=numideal[prim[i]]; pgen1=idealbase[i]; n1=lg(pgen1); k=0;
    for (j=1; j<n1; j++)
      k += itos(gmael(pgen1,j,3))*itos(gmael(pgen1,j,4));
    if (k==N)
    {
      s++; for (j=1; j<n1; j++) mat[s][ip+j]=itos(gmael(pgen1,j,3));
      for (j=1; j<=RU; j++) gaffsg(0,gmael(matarch,s,j));
    }
  }
  nbtest=ss=s;
  if (DEBUGLEVEL)
  {
    fprintferr("temps creation mat et matarch: ");
    fprintferr("%ld\n",timer2()); flusherr();
    fprintferr("Apres relations triviales, s = nbtest = %ld\n",s);
    flusherr();
  }
  liste=(long*)xmalloc(sizeof(long)*(KC+1));
  for (i=1; i<=KC; i++) liste[i]=0;
  av2=avma;
  if (DEBUGLEVEL>4)
  { fprintferr("\n** Initialisation du rang : AVMA = %ld\n",avma); flusherr(); }
  if (s)
  {
    invp=relationrank(mat,KC,s,liste);
    if (DEBUGLEVEL>1)
      fprintferr("\nRang de la matrice des relations triviales : %ld\n",s);
  }
  else invp=idmat(KC);
  if (DEBUGLEVEL>4)
  { 
    fprintferr("\n** Sortie de l'initialisation du rang : AVMA = %ld\n",avma);
    flusherr();
  }

  /* Recherche de relations par elements de petite norme */

  if (DEBUGLEVEL)
  {
    fprintferr("\n#### Recherche des relations avec elements de petite norme\n");
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }
  if (gsigne(gborne)>0)
    s=small_norm_for_buchall(s,mat,matarch,KC,KCCO,KCZ,LIMC,N,D,RU,R1,PRECREG,nf,
			     vectbase,prim,idealbase,numideal,numprim,IDN,gborne,
			     nbrelpid,invp,liste);
  avma=av2; free(liste);

  /* Recherche de relations aleatoires */

  flT2=flvp=flHONEST=0; nlze=slim=KCCO; firstime=secondtime=cmptglob=phase=0;
  iz=jideal=bouext=bou=1; limpile=(avma+bot)>>1;
  if (s==KCCO) goto HNFSPEC;
  if (DEBUGLEVEL)
  {
    fprintferr("\n#### Recherche de relations aleatoires\n"); flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }
LABELINT:
  if (!flT2){ flT2=1; lmatt2=compute_matt2(RU,nf,&nbmatt2); }
LABELVP:
  if (!flvp)
  {
    if (DEBUGLEVEL)
    {
      fprintferr("Calcul des puissances de la sub-factor base :\n");
      if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
      flusherr();
    }
    vp=powsubfactgen(nf,primsubfactorbase,CBUCHG+1,PRECREG,PRECREGINT); flvp=1;
    if (DEBUGLEVEL)
    {
      fprintferr("temps powsubfactgen: "); fprintferr("%ld\n",timer2());
      flusherr();
      if (DEBUGLEVEL>7)
      {
	fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr();
	fprintferr("\n***** LISTE DES PUISSANCES DE LA SOUS-FACTEUR BASE *****\n\n");
	for (i=1; i<lgsub; i++)
	{
	  for (j=0; j<=CBUCHG+1; j++)
	    { fprintferr("vp[%ld][%ld] = ",i,j); outerr(vp[i][j]); }
	  fprintferr("\n");
	}
      }
    }
  }
  if (flHONEST) goto LABELHONEST;
  av1=avma;
  s=random_relation(s,q,LIMC,KC,KCZ,RU,PRECREG,PRECREGINT,nf,&firstime,&secondtime,
		    &iz,&jideal,&bouext,&bou,&slim,&vinvperm,lgsub,idealbase,numideal,
		    prim,numprim,vperm,subvperm,mat,matarch,matcopy,lmatt2,nbmatt2,
		    ex,IDN,vp,nlze,&phase,&extrarel,&cmptglob,&nbtest,
		    &extramat,&extramatc);
  if (s==-1)
  {
    for (j=1; j<=KCCO; j++) free(mat[j]); free(mat);
    desallocate(primsubfactorbase,cmptglob,vp,numprim,prim,numideal,idealbase,ex,
		matcopy,vperm,subvperm,vinvperm,flvp,phase);
    if (cbach>11.99)
      err(talker,"sorry, buchxxx is not able to compute this field PLEASE REPORT!!!");
    else
    {
      avma=av0; cbach=min(2*cbach,12); cbach2=max(cbach2,cbach);
      goto INCREASEGEN;
    }
  }
HNFSPEC:

  /* Reductions des matrices des relations */

  if (!phase)
  {
    if (DEBUGLEVEL>2)
    {
      fprintferr("A la sortie : iz=%ld,",iz);
      fprintferr("jideal=%ld,bouext=%ld,bou=%ld,",jideal,bouext,bou);
      fprintferr("phase=%ld\n",phase); flusherr();
      if (DEBUGLEVEL>3){ fprintferr("***** AVMA = %ld\n",avma); flusherr(); }
      av2=avma; matgenpro=cgetg(s+1,t_MAT);
      for (j=1; j<=s; j++)
      {
	pgen1=cgetg(KC+1,t_COL); matgenpro[j]=(long)pgen1;
	for (i=1; i<=KC; i++) pgen1[i]=lstoi(mat[j][i]);
      }
      fprintferr("\nRang  = %ld, temps = %ld\n",rank(matgenpro),timer2());
      flusherr(); avma=av2;
      if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    }
    k0=lgsub-1;
    if (DEBUGLEVEL>3)
    {
      fprintferr("mat = \n");
      for (i=1; i<=KC; i++)
      {
	fprintferr("[");
	for (j=1; j<=KCCO; j++) fprintferr("%4ld",mat[j][i]); fprintferr("]\n");
      }
      fprintferr("\nmatarch = "); outerr(matarch);
    }
    matcopy=(long**)xmalloc(sizeof(long*)*(10*KCCO+1+MAXRELSUP));
    for (j=1; j<=KCCO; j++)
    {
      p1=(long *)xmalloc(sizeof(long)*(KC+1)); matcopy[j]=p1;
      for (i=1; i<=KC; i++) p1[i]=mat[j][i];
    }
    mit=hnfspec(mat,&pdep,&matarch,vperm,&matalpha,KCCO,KC,k0,&nlze,&col);
    if (DEBUGLEVEL){ fprintferr("temps hnfspec = %ld\n",timer2()); flusherr(); }
    for (j=1; j<=KCCO; j++) free(mat[j]); free(mat);
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    cmptglob=KCCO; KCCOPRO=KCCO; sfact=s; secondtime=0;
    phase=1; firstime=1;
    if (nlze)
    {
      if (avma<limpile)
      {
	gptr[0]=&mit; gptr[1]=&matarch; gptr[2]=&matalpha;
	gptr[3]=&pdep; gerepilemany(av1,gptr,4);
      }
      goto LABELINT;
    }
  }
  else
  {
    if (nrelsup) nlze=0;
    if (DEBUGLEVEL>6)
    {
      fprintferr("avant hnfadd :\n"); fprintferr("vectbase[vperm[]] = \n");
      fprintferr("[");
      for (i=1; i<=KC; i++)
      { bruterr((GEN)vectbase[vperm[i]],'g',-1); if (i<KC) fprintferr(","); }
      fprintferr("]~\n"); flusherr();
    }
    mit=hnfadd(mit,&pdep,&matarch,vperm,&matalpha,KCCOPRO,KC,col,&nlze,extramat,
	       extramatc);
    if (DEBUGLEVEL){ fprintferr("temps hnfadd = %ld\n",timer2()); flusherr(); }
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    KCCOPRO+=extrarel; col=KCCOPRO-(lg(matalpha)-1); free(vinvperm);
    if (nlze)
    {
      nreldep++;
      if (nreldep>MAXRELSUP)
      {
	desallocate(primsubfactorbase,cmptglob,vp,numprim,prim,numideal,idealbase,ex,
		    matcopy,vperm,subvperm,vinvperm,flvp,phase);
	if (cbach>11.99)
	 err(talker,"sorry, buchxxx is not able to compute this field PLEASE REPORT!!!");
	else
	{ avma=av0; cbach=min(2*cbach,12); cbach2=max(cbach2,cbach); goto INCREASEGEN; }
      }
      else
      {
	phase=1; firstime=1;
	if (avma<limpile)
	{
	  gptr[0]=&mit; gptr[1]=&matarch; gptr[2]=&matalpha;
	  gptr[3]=&pdep; gerepilemany(av1,gptr,4);
	}
	goto LABELINT;
      }
    }
  }
  phase=1; firstime=1;

/* Calcul du regulateur provisoire pour le check */

  if (DEBUGLEVEL)
  {
    fprintferr("\n#### Calcul du regulateur\n"); flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }
  reg=compute_regulator(mit,col,matarch,RU,R1,N,PRECREG,&xarch,&xreal,&image_mdet,&sreg);
  if (gexpo(reg)<=-4)
  {
    nrelsup++;
    if (nrelsup>MAXRELSUP)
    {
      desallocate(primsubfactorbase,cmptglob,vp,numprim,prim,numideal,idealbase,ex,
		  matcopy,vperm,subvperm,vinvperm,flvp,phase);
      if (cbach>11.99)
	err(talker,"sorry, buchxxx is not able to compute this field PLEASE REPORT!!!");
      else{ avma=av0; cbach=min(2*cbach,12); cbach2=max(cbach2,cbach); goto INCREASEGEN; }
    }
    else
    {
      if (DEBUGLEVEL) fprintferr("regulateur nul : \n");
      if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
      nlze=1; phase=1; firstime=1;
      if (avma<limpile)
      {
	gptr[0]=&mit; gptr[1]=&matarch; gptr[2]=&matalpha;
	gptr[3]=&pdep; gerepilemany(av1,gptr,4);
      }
      goto LABELINT;
    }
  }

  /* Calcul du nombre de classes */

  if (DEBUGLEVEL)
  {
    fprintferr("\n#### Calcul du nombre de classes\n"); flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }
  clh=compute_class_number(mit,&met,&u1,&u2);
/* u1=reducemodmatrix(u1,mit); */
  if (DEBUGLEVEL)
  {
    fprintferr("temps smith/groupe de classes: "); fprintferr("%ld\n",timer2());
    flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }

/* Calcul du check */

  if (DEBUGLEVEL)
  {
    fprintferr("\n#### Calcul du check\n"); flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }
  c_1=compute_check(mit,col,image_mdet,xreal,RU,&reg,z,zu,clh,PRECREG,&parch);
  if (gcmp0(c_1))
  {
    fprintferr("\nYou are probably being dishonest, doubling the Bach constant\n");
    flusherr();
    avma=av0; cbach=min(2*cbach,12); cbach2=max(cbach2,cbach); goto INCREASEGEN;
  }
  if (gcmpgs(gmul2n(c_1,1),3)<0) { c_1=stoi(20); nrelsup=10*MAXRELSUP; }
  if (gcmpgs(c_1,3)>0)
  {
    nrelsup++;
    if (nrelsup>MAXRELSUP)
    {
      desallocate(primsubfactorbase,cmptglob,vp,numprim,prim,numideal,idealbase,ex,
		  matcopy,vperm,subvperm,vinvperm,flvp,phase);
      if (cbach>11.99)
      {
	fprintferr("\n  ***   Warning: check is greater than 1.5, ");
	fprintferr("suggest increasing extra relations\n");
      }
      else{ avma=av0; cbach=min(2*cbach,12); cbach2=max(cbach2,cbach); goto INCREASEGEN; }
    }
    else
    {
      if (DEBUGLEVEL) fprintferr("\n ***** check = %f\n\n",gtodouble(c_1)/2);
      if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
      nlze=1; phase=1; firstime=1;
      if (avma<limpile)
      {
	gptr[0]=&mit; gptr[1]=&matarch; gptr[2]=&matalpha;
	gptr[3]=&pdep; gerepilemany(av1,gptr,4);
      }
      goto LABELINT;
    }
  }
  s=sfact;
  if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }

  /* Phase "be honest" */

  if (DEBUGLEVEL)
  {
    if (KCZ2>KCZ)
    {
      fprintferr("be honest for primes from %ld to %ld\n",prim[KCZ+1],prim[KCZ2]);
      if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    }
  }
  if ((KCZ2>KCZ)&&(!flvp)){ flHONEST=1; goto LABELVP; }
LABELHONEST:
  resuhonest=be_honest(KCZ,KCZ2,RU,PRECREGINT,IDN,s,nf,lgsub,idealbase,numideal,
		       prim,numprim,q,vp,ex,exu);
  if (!resuhonest)
  {
    desallocate(primsubfactorbase,cmptglob,vp,numprim,prim,numideal,idealbase,ex,
		matcopy,vperm,subvperm,vinvperm,flvp,phase);
    if (cbach>11.99)
      err(talker,"sorry, buchxxx is not able to compute this field PLEASE REPORT!!!");
    avma=av0; cbach=min(2*cbach,12); cbach2=max(cbach2,cbach); goto INCREASEGEN;
  }
  if (DEBUGLEVEL)
  {
    fprintferr("temps be honest: "); fprintferr("%ld\n",timer2());
    flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }

  /* Calcul des generateurs du groupe de classes */

  if (DEBUGLEVEL)
  {
    fprintferr("\n#### Calcul des generateurs du groupe des classes\n");
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }
  clgg=class_group_generators(PRECREG,PRECREGINT,nf,met,clh,u1,u2,vectbase,vperm);
  clg1=cgetg(4,t_VEC); for (i=1; i<=3; i++) clg1[i]=clgg[i];
  RES[5]=(long)clg1;
  clg2=cgetg(4,t_VEC); for (i=1; i<=3; i++) clg2[i]=clgg[i+3];
  if (DEBUGLEVEL)
  {
    fprintferr("temps generateurs du groupe de classes: ");
    fprintferr("%ld\n",timer2()); flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }

  /* regulateur, racines de l'unite et unites fondamentales */

  xarch=cleancol(gmul(xarch,parch),N,RU,PRECREG);
  RES[6]=(long)reg; z=gdiv(gmul(reg,clh),gmul((GEN)zu[1],z)); RES[7]=(long)z;
  if (flun)
  {
    pgen1=cgetg(3,t_VEC); RES[8]=(long)pgen1;
    pgen1[1]=zu[1]; pgen1[2]=lmul((GEN)nf[7],(GEN)zu[2]);
  }
  if (labs(flun)>1)
  {
    if (DEBUGLEVEL)
    {
      fprintferr("\n#### Calcul des unites fondamentales\n");
      if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    }
    fu=getfu(nf,&xarch,reg,flun,&c,PRECREG);
    if (DEBUGLEVEL)
    {
      fprintferr("temps getfu: "); fprintferr("%ld\n",timer2());
      flusherr();
      if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    }
    if ((labs(flun)>2)&&(!c))
    {
      desallocate(primsubfactorbase,cmptglob,vp,numprim,prim,numideal,idealbase,ex,
		  matcopy,vperm,subvperm,vinvperm,flvp,phase);
      prec=(prec<<1)-2; avma=av;
      if (DEBUGLEVEL)
      {
	fprintferr("Precision insuffisante pour fu, on double la precision.\n");
	fprintferr("Nouvelle precision prec = %ld\n",prec);
      }
      goto FORCEFU;
    }
    RES[9]=c?lmul((GEN)nf[7],fu):(long)fu; RES[10]=lstoi(c);
  }

/* Nettoyage et fin */

  if (DEBUGLEVEL)
  {
    fprintferr("\n#### Phase finale\n");
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }
  tetpil=avma;
  if (flun>=0) { z=cgetg(2,t_MAT); z[1]=lcopy(RES); }
  else
  {
    z=cgetg(11,t_VEC); z[1]=lcopy(mit); z[2]=lcopy(matalpha); z[3]=lcopy(xarch);
    colnew=lg(matarch)-1-sreg; pgen1=cgetg(colnew+1,t_MAT); z[4]=(long)pgen1;
    for (j=1; j<=colnew; j++)
      pgen1[j]=(long)cleancol((GEN)matarch[j+sreg],N,RU,PRECREG);
    z[5]=lcopy(vectbase); pgen1=cgetg(KC+1,t_COL); z[6]=(long)pgen1;
    for (i=1; i<=KC; i++) pgen1[i]=lstoi(vperm[i]); z[7]=lcopy(nf);
    ncz=(flun==-1)?4:6; pgen1=cgetg(ncz+1,t_VEC); z[8]=(long)pgen1;
    for (i=1; i<=ncz; i++) pgen1[i]=lcopy((GEN)RES[i+4]);
    z[9]=lcopy(clg2);
    z[10]=zero;
/* bidon mais crucial: il faut que la longueur de bnf soit differente de nf */
  }
  desallocate(primsubfactorbase,cmptglob,vp,numprim,prim,numideal,idealbase,ex,
	      matcopy,vperm,subvperm,vinvperm,flvp,phase);
  if (DEBUGLEVEL)
  {
    fprintferr("temps free finaux: "); fprintferr("%ld\n",timer2());
    flusherr();
  }
  if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  return gerepile(av,tetpil,z);
}

#if 0
/* Calcul de la base des sous-facteurs pour generer les relations entre ideaux. */
static GEN
subfactorbasegen(long N,long m,GEN vectbase,long minsfb,long *vperm,long* ptss)
{
  long av=avma,tetpil,i,ss,c,cx,k;
  GEN y,y1,p1,p;
  double prod;

  k=lg(vectbase)-1; y=cgetg(k+1,t_COL); p=gzero; c=0; prod=1.0;
  for (i=1; i<=k && (c<=minsfb || prod<m+0.5); i++)
  {
    p1=(GEN)vectbase[i];
    if (!gegal((GEN)p1[1],p))
    { 
      p=(GEN)p1[1]; y[++c]=(long)p1;
      prod*=gtodouble(gpui(p,(GEN)p1[4],0));
    }
  }
  if (c<minsfb || prod<m) { *ptss= -1; avma=av; return gzero; }

  p=gzero; ss=cx=c; y1=cgetg(cx+1,t_VEC); c=0; prod=1.0;
  for (i=1; i<=cx; i++) y1[i]=y[i];
  for (i=1; i<=k && (c<=minsfb || prod<m+0.5); i++)
  {
    p1=(GEN)vectbase[i];
    if (!gegal((GEN)p1[1],p))
    { 
      p=(GEN)p1[1]; vperm[++c]=i;
      prod*=gtodouble(gpui(p,(GEN)p1[4],0));
    }
    else vperm[++cx]=i;
  }
  for (; i<=k; i++) vperm[i]=i;
  tetpil=avma; y1=gcopy(y1); *ptss=ss; return gerepile(av,tetpil,y1);
}
#endif

static GEN
subfactorbasegen(long N,long m,GEN vectbase,long minsfb,long *vperm,long* ptss)
{
  long av=avma,tetpil,i,j, k=lg(vectbase)-1,s=0,s1=0,nbidp=0,ss=0;
  GEN y,y1,y2,perm,perm1;
  double prod;

  y=cgetg(k+1,t_COL); y1=cgetg(k+1,t_COL); y2=cgetg(k+1,t_COL);
  for (i=1; i<=k; i++)
  {
    GEN p1=(GEN)vectbase[i];
    long e,s2;

    y2[i]=lpui((GEN)p1[1],(GEN)p1[4],0);
    if (i>1 && cmpii((GEN)p1[1],gmael(vectbase,i-1,1)))
    { 
      if (s==N) y1[i-1]=zero;
      if (s1==N) ss++;
      s=0; s1=0;
    }
    e=itos((GEN)p1[3]);
    s2=e*itos((GEN)p1[4]); s+=s2; s1+=s2;
    if (e>1) { y1[i]=zero; s=0; } else y1[i]=y2[i];
  }
  if (s==N) y1[k]=zero;
  if (s1==N) ss++;
  perm=indexsort(y1);
  i=1; while (i<=k && !signe(y1[itos((GEN)perm[i])])) i++;
  if (i>k+1-minsfb) { *ptss= -1; avma=av; return gzero; }

  prod=1.0;
  while ((nbidp<=(k-i) && prod<m+0.5) || nbidp<minsfb)
  { 
    nbidp++;
    prod*=gtodouble((GEN)y1[itos((GEN)perm[nbidp+i-1])]);
  }
  if (prod<m) { *ptss= -1; avma=av; return gzero; }
  for (j=1; j<=nbidp; j++)
    y2[itos((GEN)(perm[j+i-1]))]=zero;
  perm1=indexsort(y2);
  for (j=1; j<=nbidp; j++) vperm[j]=itos((GEN)(perm[j+i-1]));
  for (j=nbidp+1; j<=k; j++) vperm[j]=itos((GEN)(perm1[j]));

  tetpil=avma; y=cgetg(nbidp+1,t_COL);
  for (j=1; j<=nbidp; j++)
    y[j]=lcopy((GEN)vectbase[itos((GEN)perm[j+i-1])]);
  *ptss=ss; return gerepile(av,tetpil,y);
}

/*Calcul la table des puissances des ideaux premiers de la base des sous-facteurs;
  w est la base des sous-facteurs, a est l'exposant maximum calcule :
  renvoie une matrice x de GEN , x[j][i] contenant
  l'ideal (P_i)^j, sous forme HNF */

static GEN **
powsubfactgen(GEN nf,GEN w,long a,long PRECREG,long PRECREGINT)
{
  long i,j,n=lg(w)-1,N=lgef(nf[1])-3,RU;
  GEN **x,pgen1,id;

  RU=itos(gmael(nf,2,1)); RU = RU + (N-RU)/2;
  x=(GEN**)xmalloc(sizeof(GEN*)*(n+1));
  for (i=1; i<=n; i++)
    x[i]=(GEN*)xmalloc(sizeof(GEN)*(a+1));
  id=cgetg(3,t_VEC); id[1]=(long)idmat(N);
  pgen1=cgetg(RU+1,t_VEC); for (i=1; i<=RU; i++) pgen1[i]=zero;
  id[2]=(long)pgen1;

  for (i=1; i<=n; i++)
  {
    x[i][0]=id;
    if (a) x[i][1] = idealmulprime(nf,id,(GEN)w[i]);
    if (DEBUGLEVEL>=2)
    { 
      fprintferr(" 0");
      if (a) fprintferr(" 1");
      flusherr();
    }
    for (j=2; j<=a; j++)
    {
      x[i][j] = idealmulprimeredall(nf,x[i][j-1],(GEN)w[i],PRECREG,PRECREGINT);
      if (DEBUGLEVEL>=2) { fprintferr(" %ld",j); flusherr(); }
    }
    if (DEBUGLEVEL>=2) { fprintferr("\n"); flusherr(); }
  }
  return x;
}

/*Calcul de la base de facteurs : n2 est la borne pour les nombres premiers
  qui vont etre testes pour obtenir toutes les relations et la norme des ideaux
  choisis, n est la borne des nombres premiers qui vont etre testes pour les
  relations primaires (constante de Bach).
  Cette fonction cree et affecte un certain nombre de variables :
  numprimfactorbase[i] est l'indice k tel que primfactorbase[k]=i (si i n'est
  pas premier, numprimfactorbase[i]=0),; primfactorbase[i] contient le i-eme
  nombre premier utilise pour construire la base de facteurs; numideal[i] est
  l'indice k tel que idealbase[k]=i; idealbase[i] contient les ideaux premiers
  de norme convenable et au dessus du nombre premier numero i;
  KCZ contient le nombre de nombres premiers utilises pour construire la base
  de facteurs jusqu'a la constante de Bach, KC contient le nombre d'ideaux
  premiers jusqu'a la constante de Bach; KCZ2 contient le nombre de nombres
  premiers de la base de facteurs au total; enfin, la fonction renvoie le
  nombre d'ideaux premiers utilises au total. On n'utilise que des nombres
  premiers ne divisant pas l'index F, et non inertes.*/

static long
factorbasegen(GEN nf,long n2,long n,long **ptnumprim,long **ptprim,long **ptnum,
	      GEN **ptideal,long *ptkc,long *ptkcz,long *ptkcz2,GEN *ptlfun)
{
  byteptr delta=diffptr;
  long av1,tetpil,i,j,k,pp,fl,lon,ip,*numprimfactorbase,*primfactorbase;
  long *numideal,ip0;
  GEN prim,pgen1,pgen2,pgen3,pgen4,*idealbase,lfun;

  numprimfactorbase=(long*)xmalloc(sizeof(long)*(n2+1));
  primfactorbase=(long*)xmalloc(sizeof(long)*(n2+1));
  numideal=(long*)xmalloc(sizeof(long)*(n2+1));
  idealbase=(GEN*)xmalloc(sizeof(GEN)*(n2+1));
  lfun=cgetr(DEFAULTPREC); affsr(1,lfun); *ptlfun=lfun;
  i=0; pp=*delta++; fl=1; ip=0; *ptkc=0;
  while (pp<=n2)
  {
    av1=avma;
    prim=stoi(pp);
    if (DEBUGLEVEL>=2) { fprintferr(" %ld",pp); flusherr(); }
    pgen1=primedec(nf,prim);
    lon=lg(pgen1); divriz(mulir(subis(prim,1),lfun),prim,lfun);
    if ((lon>2)||cmpis((GEN)((GEN)pgen1[1])[3],1)>0)
    {
      ip0=ip;
      pgen2=cgetg(lon,t_COL);
      for (j=0,k=1; k<lon; k++)
      {
	pgen3=(GEN)pgen1[k]; pgen4=gpui(prim,(GEN)pgen3[4],0);
	if (cmpis(pgen4,n2)<=0)
	{
	  ip++; j++; pgen2[j]=(long)pgen3;
	  divriz(mulir(pgen4,lfun),subis(pgen4,1),lfun);
	}
      }
      i++; numprimfactorbase[pp]=i; primfactorbase[i]=pp;
      numideal[pp]=ip0; tetpil=avma; pgen3=cgetg(j+1,t_VEC);
      for (k=1; k<=j; k++) pgen3[k]=lcopy((GEN)pgen2[k]);
      idealbase[i]=gerepile(av1,tetpil,pgen3);
    }
    else
    {
      pgen4=gpui(prim,(GEN)((GEN)pgen1[1])[4],0);
      if (cmpis(pgen4,n2)<=0)
	divriz(mulir(pgen4,lfun),subis(pgen4,1),lfun);
    }
    pp+=*delta++;
    if (pp>n && fl) { *ptkc=ip; fl=0; *ptkcz=i; }
  }
  *ptkcz2=i;
  *ptnumprim=numprimfactorbase; *ptprim=primfactorbase; *ptnum=numideal; *ptideal=idealbase;
  if (DEBUGLEVEL>=2) fprintferr("\n");
  return ip;
}

static long
factorisegen(GEN nf,GEN idealvec,long kcz,long limp,long *primfact,long *expoprimfact,
	     long *primfactorbase,GEN *idealbase,long *numideal,long *numprimfactorbase)
{
  long i,j,n1,ip,v,p,k,fl=1,av1,lo,ifinal;
  GEN x,q,r,pg1,p1,listexpo,ideal=(GEN)idealvec[1];

  av1=avma; lo=0;
  for (x=gun,i=1; i<lg(ideal); i++)
  { p1=gcoeff(ideal,i,i); if (!gcmp1(p1)) x=mulii(x,p1); }
  x=gdiv((GEN)idealvec[3],x);
  if (gcmp1(x)) { avma=av1; primfact[0]=0; return 1; }
  listexpo=cgeti(kcz+1);
  for (i=1; (i<=kcz)&&fl; i++)
  {
    p=primfactorbase[i]; q=dvmdis(x,p,&r); k=0;
    while (!signe(r))
    { 
      x=q; k++; q=dvmdis(x,p,&r);
    }
    listexpo[i]=k;
    fl=(cmpis(q,p)>0);
  }
  if (fl) { avma=av1; return 0; }

  ifinal=i-1;
  if (cmpis(x,limp)>0) { avma=av1; return 0; }
  for (i=1; i<=ifinal; i++)
  {
    p=primfactorbase[i]; k=listexpo[i];
    if (k)
    {
      pg1=idealbase[numprimfactorbase[p]];
      n1=lg(pg1); ip=numideal[p];
      for (j=1; (j<n1)&&k; j++)
      {
	v=idealval(nf,ideal,(GEN)pg1[j])-
	  element_val2(nf,(GEN)idealvec[2],(GEN)idealvec[3],(GEN)pg1[j]);
	if (v)
	{
	  primfact[++lo]=ip+j; expoprimfact[lo]=v;
	  k += v*itos(gmael(pg1,j,4));
	}
      }
      if (k) { avma=av1; return 0; }
    }
  }
  if (gcmp1(x)) { avma=av1; primfact[0]=lo; return 1; }

  p=itos(x);
  pg1=idealbase[numprimfactorbase[p]];
  n1=lg(pg1); ip=numideal[p]; k=1;
  for (j=1; (j<n1)&&k; j++)
  {
    v=idealval(nf,ideal,(GEN)pg1[j])-
      element_val2(nf,(GEN)idealvec[2],(GEN)idealvec[3],(GEN)pg1[j]);
    if (v)
    {
      primfact[++lo]=ip+j; expoprimfact[lo]=v;
      k += v*itos(gmael(pg1,j,4));
    }
  }
  if (k) { avma=av1; return 0; }
  avma=av1; primfact[0]=lo; return 1;
}

static long
factorisealpha(GEN nf,GEN alpha,long kcz,long limp,long *primfact,long *expoprimfact,
	       long *primfactorbase,GEN *idealbase,long *numideal,
	       long *numprimfactorbase)
{
  long i,j,n1,ip,v,p,k,fl=1,av1,lo,ifinal;
  GEN d,x,q,r,pg1,listexpo;

  av1=avma; lo=0;
  d=x=absi(subres(gmul((GEN)nf[7],alpha),(GEN)nf[1]));
  if (gcmp1(x)) { avma=av1; primfact[0]=0; return 1; }
  listexpo=cgeti(kcz+1);
  for (i=1; i<=kcz && fl; i++)
  {
    p=primfactorbase[i]; q=dvmdis(x,p,&r); k=0;
    while (!signe(r))
    { 
      x=q; k++; q=dvmdis(x,p,&r);
    }
    listexpo[i]=k;
    fl=(cmpis(q,p)>0);
  }
  if (fl) { avma=av1; return 0; }

  ifinal=i-1;
  if (cmpis(x,limp)>0) { avma=av1; return 0; }
  for (i=1; i<=ifinal; i++)
  {
    p=primfactorbase[i]; k=listexpo[i];
    if (k)
    {
      pg1=idealbase[numprimfactorbase[p]];
      n1=lg(pg1); ip=numideal[p];
      for (j=1; (j<n1)&&k; j++)
      {
	v=element_val2(nf,alpha,d,(GEN)pg1[j]);
	if (v)
	{
	  primfact[++lo]=ip+j; expoprimfact[lo]=v;
	  k-=v*itos((GEN)((GEN)pg1[j])[4]);
	}
      }
      if (k) { avma=av1; return 0; }
    }
  }
  if (gcmp1(x)) { avma=av1; primfact[0]=lo; return 1; }

  p=itos(x);
  pg1=idealbase[numprimfactorbase[p]];
  n1=lg(pg1); ip=numideal[p]; k=1;
  for (j=1; (j<n1)&&k; j++)
  {
    v=element_val2(nf,alpha,d,(GEN)pg1[j]);
    if (v)
    {
      primfact[++lo]=ip+j; expoprimfact[lo]=v;
      k-=v*itos((GEN)((GEN)pg1[j])[4]);
    }
  }
  if (k) { avma=av1; return 0; }
  avma=av1; primfact[0]=lo; return 1;
}

static GEN
idealmulprimeredall(GEN nf,GEN x,GEN vp,long PRECREG,long PRECREGINT)
{
  long av=avma,tetpil;
  GEN y;

  y=idealmulprime(nf,x,vp); tetpil=avma;
  return gerepile(av,tetpil,ideallllredall(nf,y,gzero,PRECREG,PRECREGINT));
}

#if 0
static GEN
idealmulprimered(GEN nf,GEN x,GEN vp,long PRECREG)
{
  long av=avma,tetpil;
  GEN y;

  y=idealmulprime(nf,x,vp); tetpil=avma;
  return gerepile(av,tetpil,ideallllredall(nf,y,gzero,PRECREG,PRECREG));
}
#endif

static GEN
cleancol(GEN x,long N,long RU,long PRECREG)
{
  long i,j,av=avma,tetpil,tx=typ(x),R1=RU+RU-N;
  GEN s,s2,p1,p2,p3,p4,y;

  if (tx==t_MAT)
  {
    y=cgetg(lg(x),tx);
    for (j=1; j<lg(x); j++)
      y[j]=(long)cleancol((GEN)x[j],N,RU,PRECREG);
    return y;
  }
  if (!is_vec_t(tx)) err(talker,"not a vector/matrix in cleancol");
  p1=greal(x); s=gzero; for (i=1; i<=RU; i++) s=gadd(s,(GEN)p1[i]);
  s=gdivgs(s,-N); if (N>R1) s2=gmul2n(s,1);
  p2=gmul2n(mppi(PRECREG),2); p3=gimag(x);
  tetpil=avma; y=cgetg(RU+1,tx);
  for (i=1; i<=RU; i++)
  {
    p4=cgetg(3,t_COMPLEX); y[i]=(long)p4;
    p4[1]=(i<=R1)?ladd((GEN)p1[i],s):ladd((GEN)p1[i],s2);
    p4[2]=(long)gmod((GEN)p3[i],p2);
  }
  return gerepile(av,tetpil,y);
}

static GEN
cleancolarch(GEN x, GEN xarch, long N,long RU,long PRECREG)
{
  long i,j,av=avma,tetpil,tx=typ(x),R1=RU+RU-N;
  GEN s,s2,p1,p2,p3,p4,y,xa;

  if (tx==t_MAT)
  {
    y=cgetg(lg(x),tx);
    for (j=1; j<lg(x); j++)
      y[j]=(long)cleancolarch((GEN)x[j],xarch,N,RU,PRECREG);
    return y;
  }
  if (!is_vec_t(tx)) err(talker,"not a vector/matrix in cleancol");
  p1=greal(x); s=gzero; for (i=1; i<=RU; i++) s=gadd(s,(GEN)p1[i]);
  s=gdivgs(s,-N); if (N>R1) s2=gmul2n(s,1);
  p2=cgetg(RU,t_COL); y=cgetg(RU+1,t_COL);
  for (i=1; i<=RU; i++)
  {
    p4=cgetg(3,t_COMPLEX); y[i]=(long)p4;
    p4[1]=(i<=R1)?ladd((GEN)p1[i],s):ladd((GEN)p1[i],s2);
    p4[2]=(long)gimag((GEN)x[i]);
    if (i<RU) p2[i]=p4[1];
  }
  if (RU<=1) x=y;
  else
  {
    p3=cgetg(RU,t_MAT);
    for (j=1; j<RU; j++)
    {
      p4=cgetg(RU,t_COL); p3[j]=(long)p4; xa=(GEN)xarch[j];
      for (i=1; i<RU; i++) p4[i]=(long)greal((GEN)xa[i]);
    }
    x=gsub(y,gmul(xarch,ground(gauss(p3,p2))));
  }
  p2=gmul2n(mppi(PRECREG),2); p3=gimag(x);
  tetpil=avma; y=cgetg(RU+1,tx);
  for (i=1; i<=RU; i++)
  {
    p4=cgetg(3,t_COMPLEX); y[i]=(long)p4;
    p4[1]=(long)greal((GEN)x[i]);
    p4[2]=(long)gmod((GEN)p3[i],p2);
  }
  return gerepile(av,tetpil,y);
}

static GEN
getfu(GEN nf,GEN *ptxarch,GEN reg,long flun,long *pte,long PRECREG)
{
  long av=avma,i,j,RU,N=lgef(nf[1])-3,e,R1,R2;
  GEN p1,p2,p3,y,matep,s,xarch;
  GEN *gptr[2];

  R1=itos((GEN)((GEN)nf[2])[1]); R2=(N-R1)>>1; RU=R1+R2; xarch=*ptxarch;
  if (RU==1) return cgetg(1,t_MAT);
  if (gexpo(reg)<-8)
  {
    if (labs(flun)==2)
    {
      fprintferr("\n  ***   Warning: not enough relations for fundamental units, ");
      fprintferr("not given\n");
    }
    *pte=0; return cgetg(1,t_MAT);
  }
  matep=cgetg(RU,t_MAT);
  for (j=1; j<RU; j++)
  {
    s=gzero; for (i=1; i<=RU; i++) s=gadd(s,greal(gcoeff(xarch,i,j)));
    s=gdivgs(s,N);
    p1=cgetg(N+1,t_COL); matep[j]=(long)p1;
    for (i=1; i<=R1; i++)
      p1[i]=lsub(gcoeff(xarch,i,j),s);
    for (i=R1+1; i<=RU; i++)
    {
      p1[i]=lsub(gmul2n(gcoeff(xarch,i,j),-1),s);
      p1[i+R2]=lconj((GEN)p1[i]);
    }
  }
  matep=gexp(gmul(matep,p1=lll(greal(matep),PRECREG)),PRECREG);
  xarch=gmul(xarch,p1);
  p1=(GEN)((GEN)nf[5])[1];
  p2=cgetg(N+1,t_MAT);
  for (j=1; j<=N; j++)
  {
    p3=cgetg(N+1,t_COL); p2[j]=(long)p3;
    for (i=1; i<=R1; i++) p3[i]=(long)coeff(p1,i,j);
    for (i=R1+1; i<=RU; i++)
    {
      p3[i]=(long)coeff(p1,i,j); p3[i+R2]=lconj((GEN)p3[i]);
    }
  }
  y=greal(grndtoi(invmulmatreel(p2,matep),&e));
  if (e>=0)
  {
    if (labs(flun)==2)
    {
      fprintferr("\n  ***   Warning: insufficient precision for fundamental units, ");
      fprintferr("not given\n");
    }
    avma=av; *pte=0; return cgetg(1,t_MAT);
  }
  *pte= -e;
  for (j=1; j<lg(y); j++)
  {
    p1=(GEN)y[j]; p2=(GEN)(ginv(gmodulcp(gmul((GEN)nf[7],p1),(GEN)nf[1]))[2]);
    p3=cgetg(N+1,t_COL); for (i=1; i<lgef(p2)-1; i++) p3[i]=p2[i+1];
    for (; i<=N; i++) p3[i]=zero;
    p2=gmul((GEN)nf[8],p3);
    if (gcmp(gnorml2(p2),gnorml2(p1))<0)
    {
      p1=p2; xarch[j]=lneg((GEN)xarch[j]);
    }
    i=N; while (i>=1 && gcmp0((GEN)p1[i])) i--;
    if (gsigne((GEN)p1[i])<0)
    {
      y[j]=lneg(p1);
      p1=cgetg(RU+1,t_COL); p2=gmul(gi,mppi(PRECREG));
      for (i=1; i<=R1; i++) p1[i]=(long)p2;
      for (; i<=RU; i++) p1[i]=lmul2n(p2,1);
      xarch[j]=(long)gadd((GEN)xarch[j],p1);
    }
    else y[j]=(long)p1;
  }
  p1=gmul((GEN)nf[7],y);
  for (j=1; j<lg(y); j++)
    if (!gcmp1(gabs(gnorm(gmodulcp((GEN)p1[j],(GEN)nf[1])),0)))
    {
      if (labs(flun)==2)
	fprintferr("\n  ***   Warning: fundamental units too large, not given\n");
      avma=av; *pte=0; return cgetg(1,t_VEC);
    }

  *ptxarch=xarch; gptr[0]=ptxarch; gptr[1]=&y;
  gerepilemany(av,gptr,2); return y;
}

GEN
buchfu(GEN bnf)
{
  GEN nf,xarch,reg,res,fu,y,sig;
  long av=avma,tetpil,c,RU;

  nf=(GEN)bnf[7]; sig=(GEN)nf[2]; RU=itos((GEN)sig[1])+itos((GEN)sig[2]);
  res=(GEN)bnf[8];
  if (lg(res)==7 && lg(res[5])==RU)
  { 
    y=cgetg(3,t_VEC); y[1]=lcopy((GEN)res[5]);
    y[2]=lcopy((GEN)res[6]); return y;
  }
  else
  {
    xarch=(GEN)bnf[3]; reg=(GEN)res[2];
    fu=getfu(nf,&xarch,reg,2,&c,gprecision(xarch));
    tetpil=avma; y=cgetg(3,t_VEC);
    y[1]=c?lmul((GEN)nf[7],fu):lcopy(fu); y[2]=lstoi(c);
    return gerepile(av,tetpil,y);
  }
}

GEN
gcdrealnoer(GEN a,GEN b,long *pte)
{
  long av,tetpil,e;
  GEN k1,r;

  if (typ(a)==t_INT)
  {
    if (typ(b)==t_INT) return mppgcd(a,b);
    k1=cgetr(lg(b)); affir(a,k1); a=k1;
  }
  else if (typ(b)==t_INT) { k1=cgetr(lg(a)); affir(b,k1); b=k1; }
  if (expo(a)<-5) return absr(b);
  if (expo(b)<-5) return absr(a);
  av=avma; a=absr(a); b=absr(b);
  while (expo(b) >= -5  && signe(b))
  {
    k1=gcvtoi(divrr(a,b),&e);
    if (e>0) { avma=av; *pte=e; return gzero; }
    r=subrr(a,mulir(k1,b)); a=b; b=r;
  }
  tetpil=avma; *pte=expo(b);
  return gerepile(av,tetpil,gabs(a,0));
}

static long
factorisegensimple(GEN nf,GEN ideal,long *primfact,long *expoprimfact,GEN vectbase)
{
  long i,p,v,av1,lo;
  GEN x,p1;

  av1=avma; lo=0; x=gun;
  for (i=1; i<lg(ideal); i++) x=mulii(x,gcoeff(ideal,i,i));
  if (gcmp1(x)) { avma=av1; primfact[0]=0; return 1; }
  for (i=1; i<lg(vectbase); i++)
  {
    p1=(GEN)vectbase[i]; p=itos((GEN)p1[1]);
    if (!signe(modis(x,p)))
    {
      v=idealval(nf,ideal,p1);
      if (v)
      {
	primfact[++lo]=i; expoprimfact[lo]=v;
	x=divii(x,gpui((GEN)p1[1],mulsi(v,(GEN)p1[4]),0));
	if (gcmp1(x)) { avma=av1; primfact[0]=lo; return 1; }
      }
    }
  }
  primfact[0]=lo; return 0;
}

#define MAXITER 50
#define IP_GEN 1
#define IP_FORCE 2

GEN
isprincipalall(GEN bignf,GEN x,long flall)
{
  long expoprimfact[500],primfact[500],av=avma,tetpil,*vinvperm;
  long i,j,fpc,colmit,colnew,k,N,R1,R2,RU,e,pr,c,nbtest,bou,q,tx=typ(x);
  long OLDDEBUGLEVEL;
  GEN xinit,xinitial,id,xalpha,yalpha,mit,matalpha,matunit,matalphac,vectbase,vperm,nf,a,RES;
  GEN u1,u2,y,p1,p2,p3,p4,p5,s,s1,s2,om1,om2,om3,xar,pgen1,pgen2,ideal,vdir,exu;
  GEN detp5,p5min,detpgen1,cycliclist,u1inv,baseclorig,clg2,RESINITIAL;
  GEN mata,p6,veca,u1u2,u,u4,p2new,smallnf;
  long *ex;

  if ((typ(bignf)!=t_VEC)||(lg(bignf)!=11))
    err(talker,"not a big number field vector in isprincipal");
  xinitial=x;
  RESINITIAL=(GEN)bignf[8];
  LABELFORCE:
  x=xinitial; mit=(GEN)bignf[1]; matalpha=(GEN)bignf[2]; matunit=(GEN)bignf[3];
  matalphac=gcopy((GEN)bignf[4]); vectbase=(GEN)bignf[5]; vperm=(GEN)bignf[6];
  nf=(GEN)bignf[7]; if ((typ(nf)!=t_VEC)||(lg(nf)<10)) err(idealer1);
  N=lgef(nf[1])-3; id=idmat(N);
  RES=(GEN)bignf[8];
  clg2=(GEN)bignf[9];

  if (tx==t_POLMOD || tx==t_POL)
  {
    if (tx==t_POLMOD)
    {
      if (!gegal((GEN)x[1],(GEN)nf[1]))
	err(talker,"not the same number field in isprincipal");
      x=(GEN)x[2];
    }
    avma=av; y=cgetg(4,t_VEC); c=lg(((GEN)RES[1])[2])-1;
    p1=cgetg(c+1,t_COL); y[1]=(long)p1; for (i=1; i<=c; i++) p1[i]=zero;
    y[2]=lmul((GEN)nf[8],x); y[3]=lstoi(BIGINT);
    return y;
  }
/*  if ((tx==17)&&(lg(x)==3)) x=(GEN)x[1];
  if ((typ(x)==t_VEC)&&(lg(x)==6)) x=idealmulprime(nf,id,x);
  if ((typ(x)!=t_MAT)||(lg(x)!=(N+1))||(lg(x[1])!=(N+1)))
    err(talker,"not an ideal in isprincipal"); */

  x=idealhermite(nf,x);
  if (N==1)
  {
    if (flall & IP_GEN)
    { y=cgetg(4,t_VEC); y[1]=lgetg(1,t_COL); y[2]=x[1]; y[3]=lstoi(BIGINT); return y; }
    else { y=cgetg(2,t_VEC); y[1]=lgetg(1,t_COL); return y; }
  }
  R1=itos((GEN)((GEN)nf[2])[1]); R2=(N-R1)>>1; RU=R1+R2;
  pr=gprecision((GEN)matalphac[1]); if (!pr) pr=8;
  colmit=lg(mit)-1; colnew=lg(matalpha)-1;
  a=content(x); x=gdiv(x,a); xinit=x=hnfmod(x,detint(x));
  vinvperm=(long*)xmalloc(lg(vectbase)<<TWOPOTBYTES_IN_LONG);
  for (i=1; i<lg(vectbase); i++) vinvperm[itos((GEN)vperm[i])]=i;
  s=gun; for (i=1; i<=N; i++) s=mulii(s,gcoeff(x,i,i));
  xar=cgetg(RU+1,t_VEC);
  for (i=1; i<=RU; i++)
  {
    p2=cgetg(3,t_COMPLEX); xar[i]=(long)p2;
    p3=cgetr(pr); p2[1]=(long)p3;
    p3=cgetr(pr); p2[2]=(long)p3;
    affsr(0,(GEN)p2[1]); affsr(0,(GEN)p2[2]);
  }
  fpc=factorisegensimple(nf,x,primfact,expoprimfact,vectbase);
  nbtest=0; ex=(long*)xmalloc(3*sizeof(long)); exu=cgetg(RU+1,t_VEC); CBUCHG=15;
  q=BITS_IN_RANDOM-1-(long)ceil(log((double)CBUCHG)/log(2.0));
  if (!fpc)
  {
    p3=cgetg(3,t_VEC); p3[1]=(long)x; p3[2]=(long)xar;
    p1=ideallllred(nf,p3,gzero,pr);
    x=(GEN)p1[1]; xar=cleancol((GEN)p1[2],N,RU,pr);
    fpc=factorisegensimple(nf,x,primfact,expoprimfact,vectbase);
    if (!fpc)
    {
      vdir=cgetg(RU+1,t_VEC); for (i=1; i<=RU; i++) vdir[i]=zero;
      for (i=1; (i<=RU)&&(!fpc); i++)
      {
	vdir[i]=lstoi(10); if (i>1) vdir[i-1]=zero;
	p1=ideallllred(nf,p3,vdir,pr);
	x=(GEN)p1[1]; xar=cleancol((GEN)p1[2],N,RU,pr);
	fpc=factorisegensimple(nf,x,primfact,expoprimfact,vectbase);
      }
      while ((!fpc)&&(nbtest<MAXITER))
      {
	for (i=1; i<=2; i++) ex[i]=mymyrand()>>q;
	ideal=idealpowprime(nf,(GEN)vectbase[itos((GEN)vperm[1])],stoi(ex[1]),pr);
	pgen1=idealpowprime(nf,(GEN)vectbase[itos((GEN)vperm[2])],stoi(ex[2]),pr);
	ideal=idealmulh(nf,idealmul(nf,p3,ideal),pgen1);
	for (bou=1; (bou<=RU)&&(!fpc); bou++)
	{
	  if (bou==1)
	  { for (i=1; i<=RU; i++) exu[i]=lstoi(mymyrand()>>q); }
	  else
	  {
	    for (i=1; i<=RU; i++) exu[i]=zero;
	    exu[bou]=lstoi(10);
	  }
	  p1=ideallllred(nf,ideal,exu,pr); nbtest++;
	  if (DEBUGLEVEL>2)
	  {
	    fprintferr("nbtest = %ld, ideal = ",nbtest);
	    outerr((GEN)p1[1]);
	  }
	  x=(GEN)p1[1]; xar=cleancol((GEN)p1[2],N,RU,pr);
	  fpc=factorisegensimple(nf,x,primfact,expoprimfact,vectbase);
	}
      }
      if (nbtest>=MAXITER)
      {
	free(ex); free(vinvperm);
	if (flall & IP_FORCE)
	{
	  pr=2*pr-2; avma=av;
	  if (DEBUGLEVEL)
	  {
	    fprintferr("doubling precision in isprincipal; newprecision=%ld\n",pr);
	    flusherr();
	  }
	  OLDDEBUGLEVEL=DEBUGLEVEL; DEBUGLEVEL=max(0,DEBUGLEVEL-2);
/*	  bignf=buchall((GEN)nf[1],dbltor(0.3),dbltor(0.3),stoi(5),gun,4,3,-1,pr); */
	  smallnf=smallbuchinit(bignf,gzero,gzero,gzero,gzero,0,0,0);
	  bignf=makebigbnf(smallnf,pr);
	  DEBUGLEVEL=OLDDEBUGLEVEL;
	  goto LABELFORCE;
	}
	else err(talker,"too many iterations in isprincipal");
      }
    }
  }
  xalpha=cgetg(colmit+1,t_COL); yalpha=cgetg(colnew+1,t_COL);
  for (i=1; i<=colmit; i++) xalpha[i]=zero;
  for (i=1; i<=colnew; i++) yalpha[i]=zero;
  if (nbtest)
  {
    for (i=1; i<=2; i++)
    {
      if (i<=colmit) xalpha[i]=lstoi(-ex[i]);
      else yalpha[i-colmit]=lstoi(-ex[i]);
    }
  }
  free(ex);
  for (i=1; i<=primfact[0]; i++)
  {
    k=vinvperm[primfact[i]];
    if (k<=colmit) xalpha[k]=laddsg(expoprimfact[i],(GEN)xalpha[k]);
    else yalpha[k-colmit]=laddsg(expoprimfact[i],(GEN)yalpha[k-colmit]);
  }
  u1inv=(GEN)clg2[1]; /* c'est l'inverse de u1 t.q.
			       u1*mit*u2=diag(cycliclist_i) */
  u2=(GEN)clg2[2];
  cycliclist=(GEN)((GEN)RES[1])[2];
  u1=ginv(u1inv);
  p1=gmul(u1,gsub(xalpha,gmul(matalpha,yalpha)));
  c=lg(cycliclist)-1;
  p4=cgetg(colmit+colnew+1,t_COL); p2=cgetg(c+1,t_COL);
  for (i=1; i<=c; i++)
  {
    p4[i]=(long)dvmdii((GEN)p1[i],(GEN)cycliclist[i],(GEN*)(p2+i));
    if (signe(p2[i])<0)
    {
      p2[i]=ladd((GEN)p2[i],(GEN)cycliclist[i]);
      p4[i]=(long)gaddgs((GEN)p4[i],-1);
    }
  }
  if (flall & IP_GEN)
  {
    for (; i<=colmit; i++) p4[i]=p1[i];
    for (; i<=colmit+colnew; i++) p4[i]=yalpha[i-colmit];
    p5=cgetg(colmit+1,t_MAT); for (i=1; i<=colmit; i++) p5[i]=matalphac[i];
    p3=gmul(p5,u2); for (i=1; i<=colmit; i++) matalphac[i]=p3[i];
    settyp(xar,t_COL); p1=gsub(gmul(matalphac,p4),xar);
    p4=cgetg(c+1,t_MAT);
    baseclorig=(GEN)clg2[3];
    for (j=1; j<=c; j++)
    {
      p5=(GEN)baseclorig[j];
      detp5=det((GEN)p5[1]); p5min=p5; pgen1=p5;
      pgen2=idealinv(nf,pgen1); pgen2[1]=(long)numer((GEN)pgen2[1]);
      detpgen1=det((GEN)pgen2[1]);
      if (gcmp(detpgen1,detp5)<0){ detp5=detpgen1; p5min=pgen2; }
      pgen2=ideallllredall(nf,pgen2,gzero,pr,pr);
      detpgen1=det((GEN)pgen2[1]);
      if (gcmp(detpgen1,detp5)<0){ detp5=detpgen1; p5min=pgen2; }
      p5=p5min;
      if (!gegal((GEN)p5[1],(GEN)((GEN)((GEN)RES[1])[3])[j]))
      { free(vinvperm); err(talker,"bug1 in isprincipal"); }
      p4[j]=lneg((GEN)p5[2]); settyp(p4[j],t_COL);
    }
    p1=cleancol(c?gadd(p1,gmul(p4,p2)):p1,N,RU,pr);
    if (RU>1)
    {
      s2=gzero;
      p4=cgetg(RU+1,t_MAT);
      for (j=1; j<RU; j++)
      {
	p5=cgetg(RU+1,t_COL); p4[j]=(long)p5;
	s1=gzero;
	for (i=1; i<RU; i++)
	{
	  p5[i] = lreal(gcoeff(matunit,i,j));
	  s1 = gadd(s1,gsqr((GEN)p5[i]));
	}
	p5[RU]=zero; if (gcmp(s1,s2)>0) s2=s1;
      }
      p5=cgetg(RU+1,t_COL); p4[RU]=(long)p5;
      for (i=1; i<RU; i++) p5[i]=(long)greal((GEN)p1[i]);
      s2=gsqrt(gmul2n(s2,RU+1),pr);
      if (gcmpgs(s2,100000000)<0) s2=stoi(100000000);
      p5[RU]=(long)s2;
      p4=(GEN)lll(p4,pr)[RU];
      if (signe(p4[RU])<0) p4=gneg(p4);
      if (!gcmp1((GEN)p4[RU]))
      { free(vinvperm); err(talker,"bug2 in isprincipal"); }
      setlg(p4,RU);
      p1=gadd(p1,gmul(matunit,p4));
      setlg(p4,RU+1);
    }
    s2=gun;
    for (j=1; j<=c; j++)
    {
      p5=(GEN)((GEN)((GEN)RES[1])[3])[j];
      s1=gun; for (i=1; i<=N; i++) s1=mulii(s1,gcoeff(p5,i,i));
      if (signe(p2[j])) s2=mulii(s2,gpui(s1,(GEN)p2[j],0));
    }
    s=gdivgs(glog(gdiv(s,s2),pr),N);
    p4=cgetg(N+1,t_COL);
    for (i=1; i<=R1; i++) p4[i]=(long)gexp(gadd(s,(GEN)p1[i]),pr);
    for (i=R1+1; i<=RU; i++)
    {
      p4[i]=(long)gexp(gadd(s,gmul2n((GEN)p1[i],-1)),pr); ;
      p4[i+R2]=lconj((GEN)p4[i]);
    }
    om1=(GEN)((GEN)nf[5])[1];
    om2=cgetg(N+1,t_MAT);
    for (j=1; j<=N; j++)
    {
      om3=cgetg(N+1,t_COL); om2[j]=(long)om3;
      for (i=1; i<=R1; i++) om3[i]=(long)coeff(om1,i,j);
      for (i=R1+1; i<=RU; i++)
      {
	om3[i]=(long)coeff(om1,i,j); om3[i+R2]=lconj((GEN)om3[i]);
      }
    }
    p1=gdiv(grndtoi(gmul(s2,greal(gauss(om2,p4))),&e),s2);
    if (e<0)
    {
      p3=cgetg(2,t_MAT); p3[1]=(long)p1;
      p5=(GEN)((GEN)RES[1])[3];
      if (!c) p3=idealmul(nf,p3,id);
      else for (j=1; j<=c; j++) p3=idealmul(nf,p3,idealpow(nf,(GEN)p5[j],(GEN)p2[j]));
      if (!gegal(xinit,p3)) e=0;
    }
    if (e>=0)
    {
      if (flall & IP_FORCE)
      {
	free(vinvperm); pr=2*pr-2; avma=av;
	if (DEBUGLEVEL)
	{
	  fprintferr("doubling precision in isprincipal; newprecision=%ld\n",pr);
	  flusherr();
	}
	OLDDEBUGLEVEL=DEBUGLEVEL; DEBUGLEVEL=max(0,DEBUGLEVEL-2);
	smallnf=smallbuchinit(bignf,gzero,gzero,gzero,gzero,0,0,0);
	bignf=makebigbnf(smallnf,pr);
/*	bignf=buchall((GEN)nf[1],dbltor(0.3),dbltor(0.3),stoi(5),gun,4,3,-1,pr); */
	DEBUGLEVEL=OLDDEBUGLEVEL;
	goto LABELFORCE;
      }
      else fprintferr("\n ***   Warning: insufficient precision for generators, not given\n");
      tetpil=avma; y=cgetg(4,t_VEC); y[1]=lcopy(p2); y[2]=lgetg(1,t_COL); y[3]=zero;
    }
    else{ tetpil=avma; y=cgetg(4,t_VEC); y[1]=lcopy(p2); y[2]=lmul(a,p1); y[3]=lstoi(-e); }
  }
  else { tetpil=avma; y=gcopy(p2); }
  free(vinvperm);
  p5=(GEN)((GEN)RES[1])[3];
  p6=(GEN)((GEN)RESINITIAL[1])[3];
  if (!gegal(p5,p6))
  {
    if (DEBUGLEVEL>=2){ fprintferr("computing new coordinates\n"); flusherr(); }
    mata=cgetg(c+1,t_MAT); veca=cgetg(c+1,t_VEC);
    for (j=1; j<=c; j++)
    {
      p1=isprincipalall(bignf,(GEN)p6[j],3);
      mata[j]=p1[1]; veca[j]=p1[2];
    }
    u1u2=hnfall(concat(diagonal(cycliclist),mata)); u=(GEN)u1u2[2];
    if (!gcmp1(det((GEN)u1u2[1]))) err(talker,"bug3 in isprincipal");
    u2=cgetg(c+1,t_MAT);
    for (j=1; j<=c; j++)
    { p1=cgetg(c+1,t_COL); u2[j]=(long)p1; for (i=1; i<=c; i++) p1[i]=coeff(u,i,j+c); }
    u4=cgetg(c+1,t_MAT);
    for (j=1; j<=c; j++)
    { p1=cgetg(c+1,t_COL); u4[j]=(long)p1; for (i=1; i<=c; i++) p1[i]=coeff(u,i+c,j+c); }
    p2new=gmul(u4,p2);
    p4=cgetg(c+1,t_VEC);
    for (i=1; i<=c; i++)
    {
      p4[i]=(long)dvmdii((GEN)p2new[i],(GEN)cycliclist[i],(GEN*)(p2+i));
      if (signe(p2[i])<0)
      {
	p2[i]=ladd((GEN)p2[i],(GEN)cycliclist[i]);
	p4[i]=(long)gaddgs((GEN)p4[i],-1);
      }
    }
    if (flall & IP_GEN) err(impl,"isprincipalgenforce");
    tetpil=avma; y=gcopy(p2);
  }
  return gerepile(av,tetpil,y);
}

GEN
isprincipal(GEN bignf,GEN x)
{
  return isprincipalall(bignf,x,0);
}

GEN
isprincipalgen(GEN bignf,GEN x)
{
  return isprincipalall(bignf,x,1);
}

GEN
isprincipalforce(GEN bignf,GEN x)
{
  return isprincipalall(bignf,x,2);
}

GEN
isprincipalgenforce(GEN bignf,GEN x)
{
  return isprincipalall(bignf,x,3);
}

#undef MAXRELSUP
#undef MAXITER

GEN
isunit(GEN bignf,GEN x)
{
  long av=avma,tetpil,tx,i,R1,RU,nru;
  GEN RES,matunit,y,p1,p2,p3,nf,ro1,pisurw,pish;

  if (typ(bignf)!=t_VEC || lg(bignf)!=11)
    err(talker,"not a big number field vector in isunit");
  tx=typ(x);
  if (is_frac_t(tx)) return cgetg(1,t_COL);
  matunit=(GEN)bignf[3]; RU=lg(matunit);
  RES=(GEN)bignf[8]; nf=(GEN)bignf[7];
  ro1=(GEN)RES[4]; nru=itos((GEN)ro1[1]);
  if (tx==t_INT)
  {
    if (!gcmp1(absi(x))) return cgetg(1,t_COL);
    y=cgetg(RU+1,t_COL);
    for (i=1; i<RU; i++) y[i]=zero;
    y[RU]=(signe(x)>0)?lmodulcp(gzero,(GEN)ro1[1]):lmodulcp(stoi(nru>>1),(GEN)ro1[1]);
    return y;
  }

  if (tx!=t_POL)
  {
    if (tx!=t_POLMOD) err(talker,"not an algebraic number in isunit");
    if (!gegal((GEN)nf[1],(GEN)x[1]))
      err(talker,"not the same number field in isunit");
    x=(GEN)x[2];
  }
  if (!gcmp1(denom(algtobasis(bignf,x))) || 
      !gcmp1(absi(gnorm(gmodulcp(x,(GEN)nf[1])))))
  { 
    avma=av; return cgetg(1,t_COL);
  }

  p1=(GEN)nf[2]; R1=itos((GEN)p1[1]);
  p1=cgetg(RU+1,t_COL);
  for (i=1; i<=R1; i++) p1[i]=un;
  for (; i<=RU; i++) p1[i]=deux;
  p3=(GEN)principalidele(nf,x)[2];
  p1=concat(matunit,p1); p2=ground(gauss(greal(p1),greal(p3)));
  if (!gcmp0((GEN)p2[RU])) err(talker,"insufficient precision (1) in isunit");
  p1=gsub(p3,gmul(p1,p2));
  pish=mppi(6); pisurw=gdivgs(pish,(itos((GEN)ro1[1])>>1));
  if (!R1) pisurw=gmul2n(pisurw,1);
  p3=(GEN)principalidele(nf,(GEN)ro1[2])[2];
  p3=gmodulcp(ground(gdiv(gimag((GEN)p3[1]),pisurw)),(GEN)ro1[1]);
  p1=gmodulcp(ground(gdiv(gimag((GEN)p1[1]),pisurw)),(GEN)ro1[1]);
  tetpil=avma; y=cgetg(RU+1,t_COL);
  for (i=1; i<RU; i++) y[i]=lcopy((GEN)p2[i]);
  y[RU]=(long)gdiv(p1,p3);
  return gerepile(av,tetpil,y);
}

GEN
signunit(GEN bignf)
{
  long av,i,j,r,R1,RU;
  GEN matunit,y,p1,p2,nf,pish;

  if (typ(bignf)!=t_VEC || lg(bignf)!=11)
    err(talker,"not a big number field vector in isunit");
  matunit=(GEN)bignf[3]; RU=lg(matunit); nf=(GEN)bignf[7];
  p1=(GEN)nf[2]; R1=itos((GEN)p1[1]); pish=mppi(6);
  y=cgetg(RU,t_MAT);
  for (j=1; j<RU; j++)
  {
    p1=cgetg(R1+1,t_COL); y[j]=(long)p1;
    for (i=1; i<=R1; i++)
    {
      av=avma; p2=ground(gdiv(gimag(gcoeff(matunit,i,j)),pish));
      r=signe(p2)?p2[lgef(p2)-1]&1:0; avma=av;
      p1[i]=r?lneg(gun):un;
    }
  }
  return y;
}

static GEN
buchall_for_degree_one_pol(GEN P,long flun)
{
  GEN RES,z,pgen1,clg2;
  long av,tetpil,i,ncz;

  av=avma;
  if (labs(flun)>1) RES=cgetg(11,t_VEC); else RES=flun?cgetg(9,t_VEC):cgetg(8,t_VEC);
  RES[1]=(long)P; pgen1=cgetg(3,t_VEC); RES[2]=(long)pgen1; pgen1[1]=un;
  pgen1[2]=zero; pgen1=cgetg(3,t_VEC); RES[3]=(long)pgen1; pgen1[1]=un; pgen1[2]=un;
  pgen1=cgetg(2,t_VEC); RES[4]=(long)pgen1; pgen1[1]=un;
  pgen1=cgetg(4,t_VEC); RES[5]=(long)pgen1; pgen1[1]=un; pgen1[2]=lgetg(1,t_VEC);
  pgen1[3]=lgetg(1,t_VEC); RES[6]=un; RES[7]=un;
  if (flun){ pgen1=cgetg(3,t_VEC); RES[8]=(long)pgen1; pgen1[1]=deux; pgen1[2]=lneg(gun); }
  if (labs(flun)>1) { RES[9]=lgetg(1,t_MAT); RES[10]=lstoi(EXP220); }
  if (flun>=0)
  { z=cgetg(2,t_MAT); z[1]=(long)RES; tetpil=avma; return gerepile(av,tetpil,gcopy(z)); }
  else
  {
    z=cgetg(11,t_VEC); z[1]=lgetg(1,t_MAT); z[2]=lgetg(1,t_MAT); z[3]=lgetg(1,t_MAT);
    z[4]=lgetg(1,t_MAT); z[5]=lgetg(1,t_COL); z[6]=lgetg(1,t_VEC);
    z[7]=(long)initalg(P,MEDDEFAULTPREC); ncz=(flun==-1)?4:6;
    pgen1=cgetg(ncz+1,t_VEC); z[8]=(long)pgen1;
    z[10]=zero;
    clg2=cgetg(4,t_VEC); clg2[1]=lgetg(1,t_MAT); clg2[2]=lgetg(1,t_MAT); clg2[3]=lgetg(1,t_VEC);
    z[9]=(long)clg2;
    for (i=1; i<=ncz; i++) pgen1[i]=lcopy((GEN)RES[i+4]); return z;
  }
}

static GEN
quad_form(GEN *cbase,GEN ma,GEN ideal,long PRECREG)
{
  long av,tetpil;
  GEN pg3,pg5,rrr;
  GEN *gptr[2];

  av=avma; pg3=gmul(gtrans(ideal),gmul(ma,ideal)); *cbase=lllgram(pg3,PRECREG);
  if (DEBUGLEVEL>6)
  {
    fprintferr(" matrice d'entree dans lllgram :\n");
    outerr(pg3);
    fprintferr(" matrice donnee par lllgram : PRECREG = %ld\n",PRECREG);
    outerr(*cbase);
  }
  pg5=gmul(gtrans(*cbase),gmul(pg3,*cbase));

  tetpil=avma; rrr=sqred1(pg5); *cbase=gcopy(*cbase);
  gptr[0]=&rrr; gptr[1]=cbase; gerepilemanysp(av,tetpil,gptr,2);
  return rrr;
}

static long
small_norm_for_buchall(long s,long **mat,GEN matarch,long KC,long KCCO,long KCZ,
   long LIMC,long N,GEN D,long RU,long R1,long PRECREG, GEN nf,GEN
   vectbase,long *prim,GEN *idealbase,long *numideal, long *numprim,
   GEN IDN,GEN gborne,long nbrelpid,GEN INVP,long *L)
{
  long av1,av2,av3,av5,n2,nbsmallnorm,nbsmallfact,nbrel,nbrelideal,tetpil2,tetpil5;
  long *x,i,j,k,l,lll,ran,noideal,fpc,expoprimfact[500],primfact[500];
  long t,ra,R2,flran;
  double eps,MINKOVSKI_BOUND,*y,*zz,**qq;
  double IDEAL_BOUND,*vv,normideal,p,quotfact;
  GEN pgen1,pgen2,pgen3,pgen4,pgen5,pg3,pg4;
  GEN matpro,vecindep,cq,bq,ma,ideal,rrr,cbase,gnormideal,invp;

  av1=avma; invp=INVP; nbrel=KCCO; n2=N+1; eps=0.000001; t=s; R2=(N-R1)>>1; pgen2=mppi(PRECREG);
  pgen1=gdiv(gsqrt(gmulsg(N,gmul2n(pgen2,1)),PRECREG),gexp(stoi(N),PRECREG));
  pgen1=gmulsg(N,gpui(pgen1,dbltor(2./(double)N),PRECREG));
  pgen3=gpui(gdivsg(4,pgen2),gdiv(stoi(2*R2),stoi(N)),PRECREG); pgen1=gmul(pgen1,pgen3);
  MINKOVSKI_BOUND=gtodouble(gmul(pgen1,gpui(gabs(D,0),dbltor(1./(double)N),PRECREG)));
  if (DEBUGLEVEL)
  { fprintferr("Borne pour les normes = %.0f\n",MINKOVSKI_BOUND); flusherr(); }
  nbsmallnorm=nbsmallfact=0;
  x=(long*)xmalloc(n2*sizeof(long)); y=(double*)xmalloc(n2*sizeof(double));
  zz=(double*)xmalloc(n2*sizeof(double)); vv=(double*)xmalloc(n2*sizeof(double));
  qq=(double**)xmalloc(n2*sizeof(double*));
  for (k=1; k<=N; k++) qq[k]=(double*)xmalloc(n2*sizeof(double));
  noideal=0; ma=gmael(nf,5,3);
  while (t<nbrel && noideal<KC)
  {
    noideal++; nbrelideal=0; av2=avma; ideal=(GEN)(vectbase[KC+1-noideal]);
    normideal=gtodouble(gnormideal=gpui((GEN)ideal[1],(GEN)ideal[4],0));
    if (DEBUGLEVEL>1)
    {
      fprintferr("\n*** Ideal no %ld : S = %ld , ",noideal,t);
      fprintferr("nombre premier = %ld , ",itos((GEN)ideal[1]));
      fprintferr("ideal = "); outerr(ideal); flusherr();
    }
    ideal=idealmul(nf,ideal,IDN); rrr=quad_form(&cbase,ma,ideal,PRECREG);
    for (k=1; k<=N; k++)
    {
      vv[k]=gtodouble(gcoeff(rrr,k,k));
      for (l=1; l<k; l++) qq[l][k]=gtodouble(gcoeff(rrr,l,k));
    }
    if (DEBUGLEVEL>3)
    {
      for (k=1; k<=N; k++) fprintferr("vv[%ld]=%.0f ",k,vv[k]);
      fprintferr("\n"); flusherr();
    }
    IDEAL_BOUND=gtodouble(gborne)*pow(normideal,2./(double)N)*MINKOVSKI_BOUND;
    if (DEBUGLEVEL>1){ fprintferr("IDEAL_BOUND  = %.0f\n",IDEAL_BOUND); flusherr(); }
    av5=avma; invp=gcopy(invp);
    k=N; y[N]=zz[N]=0; x[N]=(long)(sqrt(IDEAL_BOUND/vv[N]+eps));
    for(;;)
    {
      do
      {
	if (k>1)
	{
	  k--; zz[k]=0;
	  for (l=k+1; l<=N; l++) zz[k] += qq[k][l]*x[l];
	  p=x[k+1]+zz[k+1];
	  y[k]=y[k+1]+p*p*vv[k+1];
	  x[k]=(long) floor(sqrt((IDEAL_BOUND-y[k]+eps)/vv[k])-zz[k]);
	}
	for(;;)
	{
	  p=x[k]+zz[k];
	  if (y[k] + vv[k]*p*p <= IDEAL_BOUND+eps) break;
	  k++; x[k]--;
	}
      }
      while (k>1);
      if (!x[1] && y[1]<=eps) break;

      if (ccontent(x,N)==1)
      {
	av3=avma; flran=0;
	if (DEBUGLEVEL>4)
	{ fprintferr("** Un element trouve : AVMA = %ld\n",avma); flusherr(); }
	pg3=cgetg(N+1,t_COL); for (l=1; l<=N; l++) pg3[l]=lstoi(x[l]); pg4=pg3;
	pg3=gmul(ideal,gmul(cbase,pg3));
	j=N; while (j>=2 && !signe(pg3[j])) --j;
	if (j>1)
	{
	  if (DEBUGLEVEL>6)
	  {
	    outerr(gdiv(absi(subres(gmul((GEN)nf[7],pg3),(GEN)nf[1])),gnormideal));
	    bq=gzero;
	    for (l=1; l<=N; l++)
	    {
	      cq=gzero;
	      for (lll=l+1; lll<=N; lll++)
		cq=gadd(cq,gmul(gcoeff(rrr,l,lll),(GEN)pg4[lll]));
	      cq=gadd(cq,(GEN)pg4[l]); bq=gadd(bq,gmul(gmul(cq,cq),gcoeff(rrr,l,l)));
	    }
	    outerr(bq);
	  }
	  if ((DEBUGLEVEL>1)&&(DEBUGLEVEL<7)){ fprintferr("."); flusherr(); }
	  fpc=factorisealpha(nf,pg3,KCZ,LIMC,primfact,expoprimfact,prim,
			     idealbase,numideal,numprim);
	  nbsmallnorm++;
	  if (fpc)
	  {
	    if (t && t<KC)
	    { 
	      ran=addcolumntomatrix(KC,t,primfact,expoprimfact,&invp,L);
	      flran=1;
	    }
	    else{ ran=t+1; flran=0; }   /* astuce pour la suite ... */
	    if (DEBUGLEVEL>1 && ran==t){ fprintferr("*"); flusherr(); }
	    if (ran>t)
	    {
	      t++;
	      for (l=1; l<=primfact[0]; l++)
		mat[t][primfact[l]] = expoprimfact[l];
	      nbrelideal++; nbsmallfact++;
	      if (DEBUGLEVEL==1) { fprintferr("%4ld",t); flusherr(); }
	      if (DEBUGLEVEL>1)
	      {
		fprintferr("t = %ld",t);
		if (DEBUGLEVEL>2)
		{
		  fprintferr("[");
		  for (l=1; l<=N; l++)
		    { fprintferr(" "); bruterr((GEN)(pg3[l]),'g',-1); }
		  fprintferr(" ]");
		}
		fprintferr("\n"); flusherr();
		if (DEBUGLEVEL>1)
		{
		  fprintferr("[");
		  for (l=1; l<=KC; l++)fprintferr("%4ld",mat[t][l]);
		  fprintferr("]\n"); flusherr();
		}
	      }
	      pgen5=gmul(gmael(nf,5,1),pg3); pgen4=cgetg(RU+1,t_VEC);
	      for (l=1; l<=R1; l++)
		pgen4[l]=llog((GEN)pgen5[l],PRECREG);
	      for (l=R1+1; l<=RU; l++)
		pgen4[l]=lmul2n(glog((GEN)pgen5[l],PRECREG),1);
	      for (l=1; l<=RU; l++) 
		gaffect((GEN)(pgen4)[l],gmael(matarch,t,l));
	      if (t>=nbrel) goto LABEL2;
	      if (nbrelideal==nbrelpid) goto LABEL3;
	    }
	    if (flran) { tetpil5=avma; invp=gerepile(av5,tetpil5,gcopy(invp)); }
	    if (DEBUGLEVEL>4)
	    { 
	      fprintferr("** Un element a ete trouve : AVMA = %ld\n",avma);
	      flusherr();
	    }
	  }
	}
	if (!flran) avma=av3;
      }
      x[k]--;
    }
  LABEL3:
    tetpil2=avma; invp=gerepile(av2,tetpil2,gcopy(invp));
    if (DEBUGLEVEL>1)
    {
      fprintferr("temps pour cet ideal : "); fprintferr("%ld\n",timer2());
      flusherr();
    }
  }
LABEL2:
  avma=av1;
  if (DEBUGLEVEL>1)
  {
    fprintferr("\nLes elements de petite norme ont donne %ld relations.\n",t);
    fprintferr("\nCalcul du rang :"); flusherr(); avma=av1; matpro=cgetg(t+1,t_MAT);
    for (j=1; j<=t; j++)
    {
      pgen3=cgetg(KC+1,t_COL); matpro[j]=(long)pgen3;
      for (i=1; i<=KC; i++) pgen3[i]=lstoi(mat[j][i]);
    }
    vecindep=(GEN)(indexrank(matpro)[2]); ra=lg(vecindep)-1;
    fprintferr("rang = %ld; colonnes independantes :\n",ra); flusherr();
    for (i=1; i<=ra; i++) fprintferr("%4ld",itos((GEN)vecindep[i])); avma=av1;
    fprintferr("\ntemps du calcul du rang = %ld\n",timer2()); flusherr();
  }
  if (DEBUGLEVEL)
  {
    fprintferr("\n"); quotfact=((double)nbsmallfact)/((double)nbsmallnorm);
    fprintferr("nb. fact./nb. small norm = %ld/%ld = %f\n",
	       nbsmallfact,nbsmallnorm,quotfact);
    if (DEBUGLEVEL<4)
    { fprintferr("Temps des relations de petite norme = %ld\n",timer2()); }
    flusherr();
  }
  free(x); free(y); free(zz); free(vv);
  for (l=1; l<=N; l++) free(qq[l]); free(qq);
  return t;
}

#if 0
/* Ce programme ne differe du precedent que par le fait que l'on ne considere
   que les ideaux de la factor base au dessus de nombres premiers distincts */
long
small_norm_for_buchall(long s,long **mat,GEN matarch,long KC,long KCCO,long KCZ,
long LIMC,long N,GEN D,long RU,long R1,long PRECREG,GEN nf,GEN vectbase,
long *prim,GEN *idealbase,long *numideal,long *numprim,GEN IDN,GEN gborne,long nbrelpid)
{
  long av1,av2,av3,n2,nbsmallnorm,nbsmallfact,nbrel,nbrelideal;
  long *x,i,j,k,l,lll,noideal,fpc,expoprimfact[500],primfact[500];
  long t,trouve,nonnul,ra,R2;
  double eps,MINKOVSKI_BOUND,*y,*zz,**qq;
  double IDEAL_BOUND,*vv,normideal,p,quotfact;
  GEN pgen1,pgen2,pgen3,pgen4,pgen5,pg3,pg4;
  GEN matpro,vecindep,cq,bq,ma,ideal,rrr,cbase,gnormideal;
  GEN oldideal;

  long tetpil;

  av1=avma; nbrel=KCCO; n2=N+1; eps=0.000001; t=s; R2=(N-R1)>>1; pgen2=mppi(PRECREG);
  pgen1=gdiv(gsqrt(gmulsg(N,gmul2n(pgen2,1)),PRECREG),gexp(stoi(N),PRECREG));
  pgen1=gmulsg(N,gpui(pgen1,dbltor(2./(double)N),PRECREG));
  pgen3=gpui(gdivsg(4,pgen2),gdiv(stoi(2*R2),stoi(N)),PRECREG); pgen1=gmul(pgen1,pgen3);
  MINKOVSKI_BOUND=gtodouble(gmul(pgen1,gpui(gabs(D,0),dbltor(1./(double)N),PRECREG)));
  if (DEBUGLEVEL)
  { fprintferr("Borne pour les normes = %.0f\n",MINKOVSKI_BOUND); flusherr(); }
  nbsmallnorm=nbsmallfact=0;
  x=(long*)xmalloc(n2*sizeof(long)); y=(double*)xmalloc(n2*sizeof(double));
  zz=(double*)xmalloc(n2*sizeof(double)); vv=(double*)xmalloc(n2*sizeof(double));
  qq=(double**)xmalloc(n2*sizeof(double*));
  for (k=1; k<=N; k++) qq[k]=(double*)xmalloc(n2*sizeof(double));
  noideal=0; ma=(GEN)((GEN)nf[5])[3];
  oldideal=gzero;
  while ((t<nbrel)&&(noideal<KC))
  {
    noideal++; nbrelideal=0; av2=avma; ideal=(GEN)(vectbase[KC+1-noideal]);
    if (!gegal(ideal,oldideal))
    {
      oldideal=gcopy(ideal);
      normideal=gtodouble(gnormideal=gpui((GEN)ideal[1],(GEN)ideal[4],0));
      if (DEBUGLEVEL>1)
      {
	fprintferr("\n*** Ideal no %ld : S = %ld , ",noideal,t);
	fprintferr("nombre premier = %ld , ",itos((GEN)ideal[1]));
	fprintferr("ideal = "); outerr(ideal); flusherr();
      }
      ideal=idealmul(nf,ideal,IDN); rrr=quad_form(&cbase,ma,ideal,PRECREG);
      for (k=1; k<=N; k++)
      {
	vv[k]=gtodouble(gcoeff(rrr,k,k));
	for (l=1; l<k; l++) qq[l][k]=gtodouble(gcoeff(rrr,l,k));
      }
      if (DEBUGLEVEL>3)
      {
	for (k=1; k<=N; k++) fprintferr("vv[%ld]=%.0f ",k,vv[k]);
	fprintferr("\n"); flusherr();
      }
      IDEAL_BOUND=gtodouble(gborne)*pow(normideal,2./(double)N)*MINKOVSKI_BOUND;
      if (DEBUGLEVEL>1){ fprintferr("IDEAL_BOUND  = %.0f\n",IDEAL_BOUND); flusherr(); }
      k=N; y[N]=zz[N]=0; x[N]=(long)(sqrt(IDEAL_BOUND/vv[N]+eps));
      do
      {
	do
	{
	  if (k>1)
	  {
	    k--; zz[k]=0; for (l=k+1; l<=N; l++) zz[k]=zz[k]+qq[k][l]*x[l];
	    p=x[k+1]+zz[k+1]; y[k]=y[k+1]+p*p*vv[k+1];
	    x[k]=(long)floor(sqrt((IDEAL_BOUND-y[k]+eps)/vv[k])-zz[k]);
	  }
	  while (vv[k]*(x[k]+zz[k])*(x[k]+zz[k])>IDEAL_BOUND-y[k]+eps){ k++; x[k]--; }
	}
	while (k>1);
	if ((nonnul=(x[1]||(y[1]>eps))))
	{
	  if (ccontent(x,N)==1)
	  {
	    av3=avma; pg3=cgetg(N+1,t_COL); for (l=1; l<=N; l++) pg3[l]=lstoi(x[l]); pg4=pg3;
	    pg3=gmul(ideal,gmul(cbase,pg3)); j=N; while ((j>=2)&&(!signe(pg3[j]))) --j;
	    if (j>1)
	    {
	      if (DEBUGLEVEL>6)
	      {
		outerr(gdiv(absi(subres(gmul((GEN)nf[7],pg3),(GEN)nf[1])),gnormideal));
		bq=gzero;
		for (l=1; l<=N; l++)
		{
		  cq=gzero;
		  for (lll=l+1; lll<=N; lll++)
		    cq=gadd(cq,gmul(gcoeff(rrr,l,lll),(GEN)pg4[lll]));
		  cq=gadd(cq,(GEN)pg4[l]); bq=gadd(bq,gmul(gmul(cq,cq),gcoeff(rrr,l,l)));
		}
		outerr(bq);
	      }
	      if ((DEBUGLEVEL>1)&&(DEBUGLEVEL<7)){ fprintferr("."); flusherr(); }
	      fpc=factorisealpha(nf,pg3,KCZ,LIMC,primfact,expoprimfact,prim,
				 idealbase,numideal,numprim);
	      nbsmallnorm++;
	      if (fpc)
	      {
		t++;
		for (l=1; l<=primfact[0]; l++) mat[t][primfact[l]]=expoprimfact[l];
		trouve=already_found_relation_of_long(mat,t,KC);
		if (trouve)
		{
		  if (DEBUGLEVEL>1)
		  {
		    fprintferr("rel. elim: %ld",trouve);
		    if (DEBUGLEVEL>2)
		    {
		      fprintferr(" : [");
		      for (l=1; l<=N; l++){ fprintferr(" "); bruterr((GEN)(pg3[l]),'g',-1); }
		      fprintferr(" ]");
		    }
		    fprintferr("\n"); flusherr();
		    if (DEBUGLEVEL>1)
		    {
		      fprintferr("[");
		      for (l=1; l<=KC; l++) fprintferr("%4ld",mat[t][l]);
		      fprintferr("]\n"); flusherr();
		    }
		  }
		  for (l=1; l<=KC; l++) mat[t][l]=0; t--;
		}
		else
		{
		  nbrelideal++; nbsmallfact++;
		  if (DEBUGLEVEL==1){ fprintferr("%4ld",t); flusherr(); }
		  if (DEBUGLEVEL>1)
		  {
		    fprintferr("t = %ld",t);
		    if (DEBUGLEVEL>2)
		    {
		      fprintferr("[");
		      for (l=1; l<=N; l++){ fprintferr(" "); bruterr((GEN)(pg3[l]),'g',-1); }
		      fprintferr(" ]");
		    }
		    fprintferr("\n"); flusherr();
		    if (DEBUGLEVEL>1)
		    {
		      fprintferr("["); for (l=1; l<=KC; l++)fprintferr("%4ld",mat[t][l]);
		      fprintferr("]\n"); flusherr();
		    }
		  }
		  pgen5=gmul((GEN)((GEN)nf[5])[1],pg3); pgen4=cgetg(RU+1,t_VEC);
		  for (l=1; l<=R1; l++) pgen4[l]=(long)glog((GEN)pgen5[l],PRECREG);
		  for (l=R1+1; l<=RU; l++) pgen4[l]=lmul2n(glog((GEN)pgen5[l],PRECREG),1);
		  for (l=1; l<=RU; l++) gaffect((GEN)(pgen4)[l],(GEN)((GEN)matarch[t])[l]);
		  if (t>=nbrel) goto LABEL2; if (nbrelideal==nbrelpid) goto LABEL3;
		}
	      }
	    }
	    avma=av3;
	  }
	  x[k]--;
	}
      }
      while (nonnul);
    LABEL3:
      tetpil=avma; oldideal=gerepile(av2,tetpil,gcopy(oldideal));
      if (DEBUGLEVEL>1)
      { fprintferr("temps pour cet ideal : "); fprintferr("%ld\n",timer2()); flusherr(); }
    }
  }
LABEL2:
  avma=av1;
  if (DEBUGLEVEL>1)
  {
    fprintferr("\nLes elements de petite norme ont donne %ld relations.\n",t);
    fprintferr("\nCalcul du rang :"); flusherr(); avma=av1; matpro=cgetg(t+1,t_MAT);
    for (j=1; j<=t; j++)
    {
      pgen3=cgetg(KC+1,t_COL); matpro[j]=(long)pgen3;
      for (i=1; i<=KC; i++) pgen3[i]=lstoi(mat[j][i]);
    }
    vecindep=(GEN)(indexrank(matpro)[2]); ra=lg(vecindep)-1;
    fprintferr("rang = %ld; colonnes independantes :\n",ra); flusherr();
    for (i=1; i<=ra; i++) fprintferr("%4ld",itos((GEN)vecindep[i])); avma=av1;
    fprintferr("\ntemps du calcul du rang = %ld\n",timer2()); flusherr();
  }
  if (DEBUGLEVEL)
  {
    fprintferr("\n"); quotfact=((double)nbsmallfact)/((double)nbsmallnorm);
    fprintferr("nb. fact./nb. small norm = %ld/%ld = %f\n",nbsmallfact,
	       nbsmallnorm,quotfact);
    if (DEBUGLEVEL<4)
    { fprintferr("Temps des relations de petite norme = %ld\n",timer2()); }
    flusherr();
  }
  free(x); free(y); free(zz); free(vv); for (l=1; l<=N; l++) free(qq[l]); free(qq);
  return t;
}
#endif

#define MAXRELSUP (min(50,4*KC))

static long
random_relation(long t,long q,long LIMC,long KC,long KCZ,long RU,long PRECREG,
		long PRECREGINT,GEN nf,long *firstime,long *secondtime,long *iz,
		long *jideal,long *bouext,long *bou,long *slim,long **ptvinvperm,
		long lgsub,GEN *idealbase,long *numideal,long *prim,long *numprim,
		long *vperm,long *subvperm,long **mat,GEN matarch,long **matcopy,
		GEN lmatt2,long nbmatt2,long *ex,GEN IDN,GEN **vp,
		long nlze,long *phase,long *extrarel,
		long *cmptglob,long *nbtest,GEN *extramat,GEN *extramatc)
{
  long av,av1,i,j,k,pz,ss,fl,sinit,s,exsup;
  long fpc,primfact[500],expoprimfact[500],ep,trouve,cptzer;
  long *p1,*vinvperm;
  GEN ideal,idealpro,ideal2,idealcourant,pgen1,pgen2;

  av1=avma; cptzer=0; s=t;
  if (((*phase)==1)&&(*firstime)&&(!(*secondtime)))
  {
    *secondtime=1;
    s=0; *slim=*extrarel=nlze;
  }
  else if ((*phase)==1){ s=0; *slim=(*extrarel)=nlze; }if ((*phase)!=1) *iz=1;
  for (; s<(*slim); (*iz)++)
  {
    idealcourant=idealbase[numprim[pz=prim[(*iz-1)%KCZ+1]]];
    if ((*phase)!=1) *jideal=1;
    for (; ((*jideal)<lg(idealcourant))&&(s<(*slim)); (*jideal)++)
    {
      if (*phase)
      {
	if ((*phase)==1)
	{
	  vinvperm=(long*)xmalloc(sizeof(long)*(KC+1));
	  *ptvinvperm=vinvperm;
	  for (i=1; i<=KC; i++) vinvperm[vperm[i]]=i;
	}
	ideal=idealmulprime(nf,vp[1][0],(GEN)idealcourant[*jideal]); exsup=1;
      }
      else
      { ideal=idealmulprime(nf,vp[1][0],(GEN)idealcourant[*jideal]); exsup=1; }
      if (((*phase)!=1)||(*secondtime)) for (i=1; i<lgsub; i++) ex[i]=mymyrand()>>q;
      for (i=1; i<lgsub; i++) ideal=idealmulh(nf,ideal,(GEN)vp[i][ex[i]]);
      fl=gegal((GEN)ideal[1],IDN); av=avma; sinit=s; if ((*phase)!=1) *bouext=1;
      for (; ((*bouext)<=nbmatt2)&&(s==sinit)&&(s<(*slim)); (*bouext)++)
      {
	if ((*phase)!=1) *bou=*bouext;
	for (; ((*bou)<=nbmatt2)&&(s==sinit)&&(s<(*slim)); (*bou)++)
	{
	  if ((*phase)==1)
	  {
	    (*bou)++; (*phase)++;
	    *nbtest=0; *extramat=cgetg((*extrarel)+1,t_MAT);
	    if (DEBUGLEVEL)
            fprintferr("\n(recherche de %ld relations supplementaires)\n",*extrarel);
	    *extramatc=cgetg((*extrarel)+1,t_MAT);
	    for (j=1; j<=*extrarel; j++)
	    {
	      (*extramat)[j]=lgetg(KC+1,t_COL); pgen1=cgetg(RU+1,t_COL);
	      (*extramatc)[j]=(long)pgen1;
	      for (i=1; i<=RU; i++)
	      {
		pgen2=cgetg(3,t_COMPLEX); pgen1[i]=(long)pgen2;
		pgen2[1]=lgetr(PRECREG); pgen2[2]=lgetr(PRECREG);
	      }
	    }
	    av=avma; sinit=s;
	  }
	  if ((*bou)<=nbmatt2)
	  {
	    if (DEBUGLEVEL>2)
	    {
	      fprintferr("iz=%ld,jideal=%ld,",*iz,*jideal);
	      fprintferr("bouext=%ld,bou=%ld,phase=%ld,",*bouext,*bou,*phase);
	      fprintferr("random=%ld\n",pari_randseed);
	      if (DEBUGLEVEL>3)
	      { fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
	      flusherr();
	    }
	    idealpro=ideallllredpart1spec(nf,(GEN)ideal[1],gcoeff(lmatt2,*bouext,*bou)
					  ,1,PRECREGINT);
	    if (DEBUGLEVEL>5)
	    { fprintferr("idealpro = "); output(idealpro); flusherr(); }
	    fpc=factorisegen(nf,idealpro,KCZ,LIMC,primfact,expoprimfact,prim,
			     idealbase,numideal,numprim);
	    if (DEBUGLEVEL>1){ fprintferr("."); flusherr(); }
	    (*nbtest)++;
	    if (fpc&&(s<(*slim)))
	    {
	      ideal2=ideallllredpart2(nf,(GEN)ideal[2],(GEN)idealpro[2],PRECREG);
	      s++;
	      if (*phase)
	      {
		pgen1=(GEN)(*extramat)[s]; for (i=1; i<=KC; i++) pgen1[i]=zero;
		for (i=1; i<lgsub; i++) pgen1[vinvperm[subvperm[i]]]=lstoi(-ex[i]);
		ss=vinvperm[numideal[pz]+(*jideal)];
		pgen1[ss]=laddsi(-exsup,(GEN)pgen1[ss]);
		
		for (i=1; i<=primfact[0]; i++)
		{
		  k=vinvperm[primfact[i]]; ep=expoprimfact[i];
		  pgen1[k]=laddsg(ep,(GEN)pgen1[k]);
		}
		(*cmptglob)++; p1=(long *)xmalloc(sizeof(long)*(KC+1));
		matcopy[*cmptglob]=p1;
		for (i=1; i<=KC; i++) p1[vperm[i]]=itos((GEN)pgen1[i]);
		if (gcmp0(pgen1)){ s--; free(p1); (*cmptglob)--; }
		else
		{
		  for (i=1; i<=RU; i++)
		    gaffect((GEN)ideal2[i],(GEN)((GEN)(*extramatc)[s])[i]);
		  trouve=already_found_relation_of_long(matcopy,*cmptglob,KC);
		  if (trouve)
		  {
		    if (DEBUGLEVEL>1)
		    {
		      fprintferr("rel. elim. phase 2: %ld ",trouve);
		      if (DEBUGLEVEL>3)
		      {
			fprintferr("(iz=%ld,",*iz);
			fprintferr("jideal=%ld,bouext=%ld,",*jideal,*bouext);
			fprintferr("bou=%ld,phase=%ld)",*bou,*phase);
			if (DEBUGLEVEL>3)
			{ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
		      }
		      fprintferr("\n[");
		      for (i=1; i<=KC; i++) fprintferr("%4ld",matcopy[(*cmptglob)][i]);
		      fprintferr("]\n"); flusherr();
		    }
		    pgen1=(GEN)(*extramat)[s]; for (i=1; i<=KC; i++) pgen1[i]=zero;
		    s--; free(p1); (*cmptglob)--; cptzer++;
		    if (cptzer>MAXRELSUP){ avma=av1; return -1; }
		  }
		  else
		  {
		    cptzer=0;
		    if (DEBUGLEVEL)
		    {
		      fprintferr("\n++++ cmptglob = %ld , s = %ld ",*cmptglob,s);
		      fprintferr(":nouvelle relation:");
		      if (DEBUGLEVEL>3)
		      {
			fprintferr("(iz=%ld,",*iz);
			fprintferr("jideal=%ld,bouext=%ld,",*jideal,*bouext);
			fprintferr("bou=%ld,phase=%ld)",*bou,*phase);
		      }
		      fprintferr("\n[");
		      for (i=1; i<=KC; i++)fprintferr("%4ld",matcopy[(*cmptglob)][i]);
		      fprintferr("]\n");
		      if (DEBUGLEVEL>3)
		      fprintferr("temps pour cette relation : %ld\n",timer2());
		      if (DEBUGLEVEL>6)
		      {
			fprintferr("partie archimedienne =\n");
			for (i=1; i<=RU; i++) outerr((GEN)((GEN)(*extramatc)[s])[i]);
			for (i=1; i<=KC; i++) fprintferr("vperm[%ld]=%ld,",i,vperm[i]);
			fprintferr("\n"); flusherr();
			fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr();
		      }
		    }
		  }
		}
	      }
	      else
	      {
		for (i=1; i<lgsub; i++) mat[s][subvperm[i]]= -ex[i];
		for (i=1; i<=primfact[0]; i++) mat[s][primfact[i]]+=expoprimfact[i];
		mat[s][numideal[pz]+(*jideal)]--;
		for (i=1; i<=RU; i++) gaffect((GEN)ideal2[i],(GEN)((GEN)matarch[s])[i]);
		trouve=already_found_relation_of_long(mat,s,KC);
		if (trouve)
		{
		  if (DEBUGLEVEL>1)
		  {
		    fprintferr("rel. elim. phase 0: %ld ",trouve);
		    if (DEBUGLEVEL>3)
		    {
		      fprintferr("(iz=%ld,",*iz);
		      fprintferr("jideal=%ld,bouext=%ld,",*jideal,*bouext);
		      fprintferr("bou=%ld,phase=%ld)",*bou,*phase);
		      if (DEBUGLEVEL>6)
		      { fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
		    }
		    fprintferr("\n[");
		    for (i=1; i<=KC; i++) fprintferr("%4ld",mat[s][i]);
		    fprintferr("]\n"); flusherr();
		  }
		  for (i=1; i<=KC; i++) mat[s][i]=0; s--; cptzer++;
		  if (cptzer>MAXRELSUP){ avma=av1; return -1; }
		}
		else
                {
		  if (DEBUGLEVEL)
		  {
		    fprintferr("\n++++ s = %ld :nouvelle relation:",s);
		    if (DEBUGLEVEL>3)
		    {
		      fprintferr("(iz=%ld,",*iz);
		      fprintferr("jideal=%ld,bouext=%ld,",*jideal,*bouext);
		      fprintferr("bou=%ld,phase=%ld)",*bou,*phase);
		    }
		    fprintferr("\n[");
		    for (i=1; i<=KC; i++)fprintferr("%4ld",mat[s][i]);
		    fprintferr("]\n");
		    if (DEBUGLEVEL>3)
		    fprintferr("temps pour cette relation : %ld\n",timer2());
		    if (DEBUGLEVEL>6)
		    {
		      fprintferr("partie archimedienne =\n");
		      for (i=1; i<=RU; i++) outerr((GEN)((GEN)(matarch)[s])[i]);
		      for (i=1; i<=KC; i++) fprintferr("vperm[%ld]=%ld,",i,vperm[i]);
		      fprintferr("\n"); flusherr();
		      fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr();
		    }
		  }
		  cptzer=0;
		}
	      }
	    }
	  }
	  if (fl) goto LABBUCH;
	}
      }
    LABBUCH:
      if (((*phase)!=1)&&(sinit==s)&&(s<(*slim))) (*jideal)--;
      if ((sinit==s)||(!(*phase))) avma=av;
    }
  }
  if (s>=(*slim))
  {
    if ((*phase)!=2)
    {
      if ((*iz)>1) (*iz)--;
      if ((*jideal)>1) (*jideal)--; if ((*bouext)>1) (*bouext)--; if ((*bou)>1) (*bou)--;
    }
    else
    {
      *bouext=1; *bou=1;
      if (*jideal>=lg(idealcourant)) *jideal=1;
      else (*iz)--;
    }
  }
  return s;
}
#undef MAXRELSUP

static long
already_found_relation_of_long(long **mat,long s,long KC)
{
  long non_trouve,l,ll,lll,cca,ccb,rr,*pts,*ptl,fff;
  non_trouve=1; l=s-1;
  while (non_trouve&&(l>=1))
  {
    lll=1; while ((!mat[s][lll])&&(!mat[l][lll])) lll++;
    cca=mat[s][lll]; ccb=mat[l][lll];
    if ((!cca)||(!ccb)) l--;
    else
    {
      if (!(labs(cca)%labs(ccb))){ rr=cca/ccb; pts=mat[s]; ptl=mat[l]; fff=1; }
      else if (!(labs(ccb)%labs(cca))){ rr=ccb/cca; pts=mat[l]; ptl=mat[s]; fff=1; }
      else{ fff=0; l--; }
      if (fff)
      { ll=lll+1; while ((ll<=KC)&&(pts[ll]==(rr*ptl[ll]))) ll++; non_trouve=(ll<=KC); l--; }
    }
  }
  if (non_trouve) return 0; else return l+1;
}

static void
desallocate(GEN primsubfactorbase,long cmptglob,GEN **vp,long *numprim,long *prim,
	    long *numideal,GEN *idealbase,long *ex,long **matcopy,long *vperm,
	    long *subvperm,long *vinvperm,long flvp,long phase)
{
  long i;
  free(numprim); free(prim); free(numideal); free(idealbase); free(ex);
  free(vperm); free(subvperm);
  if (flvp){ for (i=1; i<lg(primsubfactorbase); i++) free(vp[i]); free(vp); }
  if (phase)
  {
    for (i=1; i<=cmptglob; i++) free(matcopy[i]); free(matcopy);
  }
}

static GEN
compute_regulator(GEN mit,long col,GEN matarch,long RU,long R1,long N,long PRECREG,
		  GEN *xarch,GEN *xreal,GEN *image_mdet,long *ptsreg)
{
  long sizeofmit,sreg,i,j,av;
  GEN vei,mdet,reg;
  GEN *gptr[4];

  av=avma; sizeofmit=lg(mit)-1; sreg=col-sizeofmit;
  *xarch=cgetg(sreg+1,t_MAT); for (j=1; j<=sreg; j++) (*xarch)[j]=matarch[j];
  (*xreal)=greal(*xarch);
  vei=cgetg(RU+1,t_COL); for (i=1; i<=RU; i++) vei[i]=(i<=R1)?un:deux;
  mdet=cgetg(sreg+2,t_MAT); for (j=2; j<=sreg+1; j++) mdet[j]=(*xreal)[j-1];
  mdet[1]=(long)vei;
  if (DEBUGLEVEL)
  {
    fprintferr("temps trivialites xarch, xreal, mdet: ");
    fprintferr("%ld\n",timer2()); flusherr();
  }
  *image_mdet=imagereel(mdet,PRECREG);
  if (DEBUGLEVEL)
  {
    fprintferr("temps imagereel: "); fprintferr("%ld\n",timer2());
    flusherr();
  }
  if (lg(*image_mdet)!=(RU+1)) affsr(0,reg=cgetr(PRECREG));
  else reg=gdivgs(gabs(detreel(*image_mdet),PRECREG),N);
  if (DEBUGLEVEL)
  {
    fprintferr("temps detreel: "); fprintferr("%ld\n",timer2());
    flusherr();
  }

  gptr[0]=xarch; gptr[1]=xreal; gptr[2]=image_mdet; gptr[3]=&reg;
  gerepilemany(av,gptr,4);

  *ptsreg=sreg; return reg;
}

/* sort u2 et l'inverse de u1 */
GEN
compute_class_number(GEN mit,GEN *met,GEN *u1,GEN *u2) 
{
  long i, lmit=lg(mit)-1;

  if (lmit)
  {
    GEN *gptr[4], pgen1,clh,u1u2;
    long av = avma;

    u1u2=smith2(mit); *u1=(GEN)u1u2[1]; *u2=(GEN)u1u2[2];
    pgen1=(GEN)u1u2[3]; *u1=ginv(*u1); *met=pgen1;
    clh=gun;
    for (i=1; i<=lmit; i++) clh=mulii(clh,gcoeff(pgen1,i,i));
    gptr[0]=met; gptr[1]=u1; gptr[2]=u2; gptr[3]=&clh;
    gerepilemany(av,gptr,4);
    return clh;
  }
  *met=cgetg(1,t_MAT); *u1=cgetg(1,t_MAT); *u2=cgetg(1,t_MAT);
  return gun;
}

static GEN
compute_check(GEN mit,long col,GEN image_mdet,GEN xreal,long RU,GEN *reg,GEN z,
	      GEN zu,GEN clh,long PRECREG,GEN *parch)
{
  long sizeofmit,sreg,i,j,av;
  GEN lambda,sublambda_1,pgen2,pgen3,c_1,den;
  GEN *gptr[3];

  sizeofmit=lg(mit)-1; sreg=col-sizeofmit; av=avma;
  lambda=invmulmatreel(image_mdet,xreal); sublambda_1=cgetg(sreg+1,t_MAT);
  for (i=1; i<=sreg; i++)
  {
    pgen2=cgetg(RU,t_COL); sublambda_1[i]=(long)pgen2; pgen3=(GEN)lambda[i];
    for (j=1; j<RU; j++) pgen2[j]=pgen3[j+1];
  }
  if (DEBUGLEVEL)
  {
    fprintferr("temps trivialites lambda: "); fprintferr("%ld\n",timer2());
    flusherr();
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
  }
  c_1=gmul2n(gdiv(*reg,gdiv(gmul(z,(GEN)zu[1]),clh)),1);
  sublambda_1=bestappr(sublambda_1,c_1); den=denom(sublambda_1);
  if (gcmp(den,c_1)>0){ avma=av; return gzero; }
  *parch=(GEN)lllkerim(gmul(sublambda_1,den))[2];
  *reg=gabs(gmul(*reg,det(gmul(sublambda_1,*parch))),PRECREG);
  c_1=gmul2n(gdiv(*reg,gdiv(gmul(z,(GEN)zu[1]),clh)),1);
  if (DEBUGLEVEL)
  {
    fprintferr("temps bestappr/regulateur: "); fprintferr("%ld\n",timer2());
    flusherr();
  }

  gptr[0]=reg; gptr[1]=parch; gptr[2]=&c_1;
  gerepilemany(av,gptr,3); return c_1;
}

static long
be_honest(long KCZ,long KCZ2,long RU,long PRECREGINT,GEN IDN,long s,GEN nf,
	  long lgsub,GEN *idealbase,long *numideal,long *prim,long *numprim,
	  long q,GEN **vp,long *ex,GEN exu)
{
  long av,av1,i,j,iz1,pz,sinit,nbtest,bouh,fpc,primfact[500],expoprimfact[500];
  GEN pgen1,ideal,idealpro;

  av=avma;
  for (iz1=KCZ+1; iz1<=KCZ2; iz1++)
  {
    pgen1=idealbase[numprim[pz=prim[iz1]]];
    if (DEBUGLEVEL>1) fprintferr(" %ld,",pz);
    for (j=1; j<lg(pgen1); j++)
    {
      sinit=s; nbtest=0;
      do
      {
	for (i=1; i<lgsub; i++) ex[i]=mymyrand()>>q; av1=avma;
	ideal=idealmulprime(nf,IDN,(GEN)pgen1[j]);
	for (i=1; i<lgsub; i++) ideal=idealmulh(nf,ideal,(GEN)vp[i][ex[i]]);
	for (bouh=1; (bouh<=RU)&&(s==sinit); bouh++)
	{
	  if (bouh==1) { for (i=1; i<=RU; i++) exu[i]=lstoi(mymyrand()>>q); }
	  else{ for (i=1; i<=RU; i++) exu[i]=zero; exu[bouh]=lstoi(10); }
	  idealpro=ideallllredpart1(nf,ideal,exu,1,PRECREGINT); nbtest++;
	  fpc=factorisegen(nf,idealpro,iz1-1,prim[iz1-1],primfact,expoprimfact,
			   prim,idealbase,numideal,numprim);
	  if (fpc) s++;
	}
	avma=av1;
      }
      while ((sinit==s)&&(nbtest<20));
      if (sinit==s){ avma=av; return 0; }
    }
  }
  avma=av; return 1;
}

static GEN
class_group_generators(long PRECREG,long PRECREGINT,GEN nf,
		       GEN met,GEN clh,GEN u1,GEN u2,GEN vectbase,long *vperm)
{
  long av,tetpil,i,j,c,lo,s;
  GEN basecl,p3,pgen1,pgen2,mot,detp3,p3min,detpgen1,comul,baseclorig;

  av=avma; lo=lg(met)-1;
  c=0; for (i=1; i<=lo; i++) if (!gcmp1(gcoeff(met,i,i))) c++; basecl=cgetg(c+1,t_VEC);
  baseclorig=cgetg(c+1,t_VEC);
  if (DEBUGLEVEL)
  {
    fprintferr("temps trivialites cleancol: "); fprintferr("%ld\n",timer2());
    flusherr();
  }
  for (j=1; j<=c; j++)
  {
    p3=idealpowprime(nf,(GEN)vectbase[vperm[1]],pgen1=gcoeff(u1,1,j),PRECREG);
    if (signe(pgen1)<0) p3=numer(p3);
    for (i=2; i<=lo; i++)
    {
      pgen1=gcoeff(u1,i,j); s=signe(pgen1);
      if (s)
      {
	if (s>0)
	  p3=idealmulh(nf,p3,idealpowprime(nf,(GEN)vectbase[vperm[i]],pgen1,PRECREGINT));
	else
	  p3=idealmulh(nf,p3,numer((GEN)idealpowprime(nf,(GEN)vectbase[vperm[i]],
						      pgen1,PRECREGINT)));
	p3=ideallllredall(nf,p3,gzero,PRECREGINT,PRECREGINT);
      }
    }
    baseclorig[j]=(long)p3; p3=(GEN)p3[1];
    detp3=det(p3); p3min=p3; pgen1=p3; comul=gun;
    pgen2=numer(idealinv(nf,pgen1));
    detpgen1=det(pgen2);
    if (gcmp(detpgen1,detp3)<0){ detp3=detpgen1; p3min=pgen2; comul=stoi(-1); }
    pgen2=ideallllredall(nf,pgen2,gzero,PRECREGINT,PRECREGINT);
    detpgen1=det(pgen2);
    if (gcmp(detpgen1,detp3)<0){ detp3=detpgen1; p3min=pgen2; }
    basecl[j]=(long)p3min;
    if (!gcmp1(comul)){ u1[j]=lmul(comul,(GEN)u1[j]); u2[j]=lmul(comul,(GEN)u2[j]); }
  }
  mot=cgetg(c+1,t_VEC); for (i=1; i<=c; i++) mot[i]=coeff(met,i,i);
  pgen1=cgetg(7,t_VEC); pgen1[1]=(long)clh;
  pgen1[2]=(long)mot; pgen1[3]=(long)basecl; pgen1[4]=(long)u1;
/* u1 contient l'inverse de u telle que u*mit*u2=diag(cycliclist_i) */
  pgen1[5]=(long)u2; pgen1[6]=(long)baseclorig;
  tetpil=avma; return gerepile(av,tetpil,gcopy(pgen1));
}

static GEN
compute_matt2(long RU,GEN nf,long *nbmatt2)
{
  long av,tetpil,i,j,k;
  GEN lmatt2,pgen1,pgen2,pgen3,pgen4;

  if (DEBUGLEVEL)
  {
    fprintferr("Calcul des matrices T2 avec poids : ");
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    flusherr();
  }
  if (RU<10) *nbmatt2=RU; else *nbmatt2=9; av=avma;
  lmatt2=cgetg((*nbmatt2)+1,t_MAT); pgen1=(GEN)nf[5]; pgen3=(GEN)pgen1[2];
  for (j=1; j<=(*nbmatt2); j++)
  {
    pgen2=cgetg(*nbmatt2+1,t_COL); lmatt2[j]=(long)pgen2;
    for (i=1; i<=(*nbmatt2); i++)
    {
      if (j<i) pgen2[i]=zero;
      else
      {
	pgen4=cgetg(RU+1,t_MAT); for (k=1; k<=RU; k++) pgen4[k]=pgen3[k];
	pgen4[i]=lmul2n((GEN)pgen3[i],20); if (i!=j) pgen4[j]=lmul2n((GEN)pgen3[j],20);
	pgen2[i]=lreal(gmul(pgen4,(GEN)pgen1[1]));
      }
    }
  }
  if (DEBUGLEVEL)
  {
    fprintferr("temps matrices T2 avec poids : "); fprintferr("%ld\n",timer2());
    if (DEBUGLEVEL>7){ fprintferr("$$$$$ AVMA = %ld\n",avma); flusherr(); }
    flusherr();
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(lmatt2));
}

/* Programmes de calcul du rang d'une matrice A de M_{ n,r }(Q) avec rang(A)= r <= n
   On transforme peu a peu la matrice  I dont les colonnes sont les vecteurs de la
   base canonique de Q^n en une matrice de changement de base P obtenue en prenant
   comme base les colonnes de A independantes et des vecteurs de la base
   canonique. On rend P^(-1) , L un vecteur ligne a n composantes
   valant 0 ou 1 selon que le le vecteur correspondant de P est e_i ou x_i
   (e_i vecteur de la base canonique, x_i i-eme colonne de A) */

static GEN
relationrank(long **mat,long n,long r,long *L)
{
  long av,tetpil,av1,tetpil1,i,j,k,ii;
  GEN ptinvp,y,p1,p2,matpro;

  if (r>n) err(talker,"incorrect matrix in relationrank");
  if (DEBUGLEVEL>4)
  { fprintferr("\n** entree ds relationrank() : AVMA = %ld\n",avma); flusherr(); }
  av=avma; matpro=cgetg(r+1,t_MAT);
  for (j=1; j<=r; j++)
  { p1=cgetg(n+1,t_COL); matpro[j]=(long)p1; for (i=1; i<=n; i++) p1[i]=lstoi(mat[j][i]); }
  ptinvp=idmat(n);
  for (ii=1; ii<=r; ii++)
  {
    av1=avma; y=gmul(ptinvp,(GEN)matpro[ii]); k=1;
    while ((k<=n)&&((gcmp0((GEN)y[k]))||(L[k]))) k++;
    if ((k>n)&&(ii==r)) err(talker,"not a maximum rank matrix in relationrank");
    p1=cgetg(n+1,t_MAT);
    for (j=1; j<=n; j++)
    {
      p2=cgetg(n+1,t_COL); p1[j]=(long)p2;
      if (j==k)
      {
	for (i=1; i<k; i++) p2[i]=zero;
	p2[k]=ldiv(gcoeff(ptinvp,k,k),(GEN)y[k]);
	for (i=k+1; i<=n; i++)
	  p2[i]=lmul(gdiv(gneg((GEN)y[i]),(GEN)y[k]),gcoeff(ptinvp,k,k));
      }
      else if (j>k) p1[j]=ptinvp[j];
      else
      {
	for (i=1; i<j; i++) p2[i]=zero;
	for (i=j; i<k; i++) p2[i]=(long)gcoeff(ptinvp,i,j);
	p2[k]=ldiv(gcoeff(ptinvp,k,j),(GEN)y[k]);
	for (i=k+1; i<=n; i++)
	  p2[i]=ladd(gcoeff(ptinvp,i,j),gmul(gdiv(gneg((GEN)y[i]),(GEN)y[k]),
					     gcoeff(ptinvp,k,j)));
      }
    }
    tetpil1=avma; ptinvp=gerepile(av1,tetpil1,gcopy(p1));
    L[k]=1;
/*
    Q=idmat(n); Q[k]=(long)y;
    ptinvp=gmul(ginv(Q),ptinvp);
*/
  }
  tetpil=avma; p1=gerepile(av,tetpil,gcopy(ptinvp));
  if (DEBUGLEVEL>4)
  { fprintferr("** sortie de relationrank() : AVMA = %ld\n",avma); flusherr(); }
  return p1;
}

/* Etant donnes une matrice dans M_{ n,r }(Q), de rang maximum r < n, un vecteur
   colonne V a n lignes, la matrice *INVP et le vecteur ligne *L donnes par
   le programme relationrank() ci-dessus, on teste si le vecteur V est lineairement
   independant des colonnes de la matrice; si la reponse est non, on rend le rang
   de la matrice; si la reponse est oui, on rend le rang de la matrice + 1, on
   met dans *INVP l'inverse de la nouvelle matrice *INVP et dans
   *L le nouveau vecteur ligne *L */

static long
addcolumntomatrix(long n,long r,long *primfact,long *expoprimfact,
		  GEN *INVP,long *L)
{
  long av,tetpil,i,j,k;
  GEN ptinvp,y,p1,p2,V;

  if (DEBUGLEVEL>4)
  { fprintferr("\n*** entree ds addcolumntomatrix() : AVMA = %ld\n",avma); flusherr(); }
  if (!r) err(talker,"empty matrix in addcolumntomatrix");
  if (r>=n) err(talker,"maximum rank matrix in addcolumntomatrix");
  av=avma;
  V=cgetg(n+1,t_COL);
  for (i=1; i<=n; i++) V[i]=zero;
  for (i=1; i<=primfact[0]; i++) V[primfact[i]]=lstoi(expoprimfact[i]);
  ptinvp=*INVP; y=gmul(ptinvp,V);
  if (DEBUGLEVEL>6)
  {
    fprintferr("vecteur = \n"); outerr(V);
    fprintferr("vecteur ds new base = \n"); outerr(y);
    fprintferr("matrice de passage = \n"); outerr(ptinvp);
    fprintferr("liste = [");
    for (i=1; i<=n-1; i++) fprintferr("%ld,",L[i]); fprintferr("%ld]\n",L[n]);
    flusherr();
  }
  k=1; while ((k<=n)&&((gcmp0((GEN)y[k]))||(L[k]))) k++;
  if (k>n)
  {
    avma=av;
    if (DEBUGLEVEL>4)
    { fprintferr("*** sortie de addcolumntomatrix() : AVMA = %ld\n",avma); flusherr(); }
    return r;
  }
  else
  {
    p1=cgetg(n+1,t_MAT);
    for (j=1; j<=n; j++)
    {
      p2=cgetg(n+1,t_COL); p1[j]=(long)p2;
      if (j==k)
      {
	for (i=1; i<k; i++) p2[i]=zero;
	p2[k]=ldiv(gcoeff(ptinvp,k,k),(GEN)y[k]);
	for (i=k+1; i<=n; i++)
	  p2[i]=lmul(gdiv(gneg((GEN)y[i]),(GEN)y[k]),gcoeff(ptinvp,k,k));
      }
      else if (j>k) p1[j]=ptinvp[j];
      else
      {
	for (i=1; i<j; i++) p2[i]=zero;
	for (i=j; i<k; i++) p2[i]=(long)gcoeff(ptinvp,i,j);
	p2[k]=ldiv(gcoeff(ptinvp,k,j),(GEN)y[k]);
	for (i=k+1; i<=n; i++)
	  p2[i]=ladd(gcoeff(ptinvp,i,j),gmul(gdiv(gneg((GEN)y[i]),(GEN)y[k]),
					     gcoeff(ptinvp,k,j)));
      }
    }
/*
    Q=idmat(n); Q[k]=(long)y;
    ptinvp=gmul(ginv(Q),ptinvp);
*/
    L[k]=1; tetpil=avma; *INVP=gerepile(av,tetpil,gcopy(p1));
    if (DEBUGLEVEL>4)
    { fprintferr("*** sortie de addcolumntomatrix() : AVMA = %ld\n",avma); flusherr(); }
    return r+1;
  }
}

static GEN
classintern(GEN nf,GEN mit,GEN vectbase)
/* a usage special: uniquement pour passer du format smallbnf au format bnf
Ici, vectbase est deja permute, donc pas de vperm. A l'effet
de compute_class_number() suivi de class_group_generators(). */
{
  long av=avma,tetpil,i,lv;
  int PREC;

  GEN clh,met,u1,u2,vperm;

  clh=compute_class_number(mit,&met,&u1,&u2);
  lv=lg(vectbase); vperm=cgetg(lv,t_VEC);
  for (i=1; i<lv; i++) vperm[i]=i;
  PREC=gprecision((GEN)nf[6]);
  tetpil=avma;
  return gerepile(av,tetpil,class_group_generators(PREC,PREC,nf,met,clh,u1,u2,vectbase,vperm));
}

static GEN
codeprime(GEN bnf, GEN pr)
{
  long indi,j,av=avma,tetpil;
  GEN p,al,fa,p1;

  p=(GEN)pr[1]; al=(GEN)pr[2]; pari_randseed=1; fa=primedec(bnf,p); indi=0;
  for (j=1; (!indi)&&(j<lg(fa)); j++)
    if (gegal(al,(GEN)((GEN)fa[j])[2])) indi=j;
  if (!indi) err(talker,"bug in codeprime/smallbuchinit");
  p1=mulsi(lg(al)-1,p); tetpil=avma;
  return gerepile(av,tetpil,addsi(indi-1,p1));
}

static GEN
decodeprime(GEN nf, GEN co)
{
  long n,indi,av=avma,tetpil;
  GEN p,rem,p1;

  n=lg(nf[7])-1; p=dvmdis(co,n,&rem); indi=itos(rem)+1;
  pari_randseed=1; p1=primedec(nf,p);
  tetpil=avma; return gerepile(av,tetpil,gcopy((GEN)p1[indi]));
}

static GEN
makematal(GEN bnf)
{
  GEN mit,matalpha,pfb,vp,nf,ma,pr,id;
  long lm,lma,av=avma,tetpil,j,k;

  mit=(GEN)bnf[1]; matalpha=(GEN)bnf[2];
  pfb=(GEN)bnf[5]; vp=(GEN)bnf[6]; nf=(GEN)bnf[7];
  lm=(lg(mit)>1)?lg(mit[1])-1:0; lma=lm+lg(matalpha);
  ma=cgetg(lma,t_MAT);
  for (j=1; j<lma; j++)
  {
    id=(j<=lm)?gun:(GEN)pfb[itos((GEN)vp[j])];
    for (k=1; k<=lm; k++)
    {
      pr=(GEN)pfb[itos((GEN)vp[k])];
      id=idealmul(nf,id,idealpow(nf,pr,(j<=lm)?gcoeff(mit,k,j):gcoeff(matalpha,k,j-lm)));
    }
    ma[j]=isprincipalgen(bnf,id)[2];
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(ma));
}
			
GEN
smallbuchinit(GEN pol,GEN gcbach,GEN gcbach2,GEN gRELSUP,GEN gborne,long nbrelpid,long minsfb,long prec)
{
  long av=avma,tetpil,k;
  GEN y,bnf,pfb,vp,nf,mas,res,uni,v1,v2,v3;

  if (typ(pol)==t_VEC) { checkbnf(pol); bnf=pol; }
  else bnf=buchall(pol,gcbach,gcbach2,gRELSUP,gborne,nbrelpid,minsfb,-3,prec);
  pfb=(GEN)bnf[5]; vp=(GEN)bnf[6]; nf=(GEN)bnf[7];
  mas=(GEN)nf[5]; res=(GEN)bnf[8]; uni=(GEN)res[5];
  tetpil=avma;
  y=cgetg(13,t_VEC); y[1]=lcopy((GEN)nf[1]); y[2]=lcopy(gmael(nf,2,1));
  y[3]=lcopy((GEN)nf[3]); y[4]=lcopy((GEN)nf[7]);
  y[5]=lcopy((GEN)nf[6]); y[6]=lcopy((GEN)mas[5]);
  y[7]=lcopy((GEN)bnf[1]); y[8]=lcopy((GEN)bnf[2]);
  v1=cgetg(lg(pfb),t_VEC); y[9]=(long)v1;
  for (k=1; k<lg(pfb); k++)
    v1[k]=(long)codeprime(bnf,(GEN)pfb[itos((GEN)vp[k])]);
  v2=cgetg(3,t_VEC); y[10]=(long)v2; v2[1]=lcopy(gmael(res,4,1));
  v2[2]=(long)algtobasis(bnf,gmael(res,4,2));
  v3=cgetg(lg(uni),t_VEC); y[11]=(long)v3;
  for (k=1; k<lg(uni); k++) v3[k]=(long)algtobasis(bnf,(GEN)uni[k]);
  y[12]=(long)makematal(bnf);
  return gerepile(av,tetpil,y);
}

GEN
makebigbnf(GEN sbnf, long prec)
{
  GEN eps,p1,pol,bas,ro,m,mul,pok,m1,m2,m3,t2,mas,t,ti,nf,v1,v2,v3,mun,funits;
  GEN pfc,vp,pfb,alphs,mc,clgg,res,p2,y,mit,mata,racu;
  long i,j,k,n,r1,r2,la,ru,lpf,av=avma,tetpil,vla,wprec,v;

  eps=gpuigs(dbltor(10.),-10);
  pol=(GEN)sbnf[1]; r1=itos((GEN)sbnf[2]); n=lg(sbnf[4])-1; r2=(n-r1)/2;
  bas=(GEN)sbnf[4]; ro=(GEN)sbnf[5]; v=varn(pol);
  if (prec>gprecision(ro))
  {
    p2=roots(pol,prec); for (i=1; i<=r1; i++) p2[i]=lreal((GEN)p2[i]);
    ru=r1+r2; ro=cgetg(ru+1,t_VEC);
    for (i=1; i<=ru; i++) ro[i]=p2[max(i,(i<<1)-r1)];
  }
  m=cgetg(n+1,t_MAT);
  for (k=1; k<=n; k++)
  {
    p1=cgetg(n+1,t_COL); m[k]=(long)p1; p2=(GEN)bas[k];
    for (j=1; j<=n; j++) p1[j]=(long)truecoeff(p2,j-1);
  }
  m=invmat(m);
  mul=cgetg(n*n+1,t_MAT);
  for (k=1; k<=n*n; k++)
  {
    pok=gres(gmul((GEN)bas[(k-1)%n+1],(GEN)bas[(long)((k-1)/n)+1]),pol);
    p1=cgetg(n+1,t_COL); mul[k]=(long)p1;
    for (j=1; j<=n; j++) p1[j]=(long)truecoeff(pok,j-1);
  }
  mul=gmul(m,mul);
  m1=cgetg(n+1,t_MAT);
  for (k=1; k<=n; k++)
  {
    p1=cgetg(r1+r2+1,t_COL); m1[k]=(long)p1;
    for (j=1; j<=r1+r2; j++) p1[j]=(long)gsubst((GEN)bas[k],v,(GEN)ro[j]);
  }
  m2=cgetg(r1+r2+1,t_MAT);
  for (j=1; j<=r1+r2; j++)
  {
    p1=cgetg(n+1,t_COL); m2[j]=(long)p1;
    for (k=1; k<=n; k++)
      p1[k]=(j<=r1)?(long)gsubst((GEN)bas[k],v,(GEN)ro[j]):(long)gmul2n(gsubst((GEN)bas[k],v,gconj((GEN)ro[j])),1);
  }
  t2=greal(gmul(m2,m1)); m3=greal(gmul(gconj(m2),m1)); t=ground(m3);
  if (gcmp(gnorml2(gsub(m3,t)),eps)>0)
    err(talker,"insufficient precision in makebignf");
  ti=gmul((GEN)sbnf[3],invmat(t));
  mas=cgetg(8,t_VEC); mas[1]=(long)m1; mas[2]=(long)m2; mas[3]=(long)t2;
  mas[4]=(long)t; mas[5]=sbnf[6]; mas[6]=(long)ti;
  mas[7]=(long)hnfmod(ti,detint(ti));
  nf=cgetg(10,t_VEC); nf[1]=sbnf[1]; p1=cgetg(3,t_VEC); nf[2]=(long)p1;
  p1[1]=lstoi(r1); p1[2]=lstoi(r2); nf[3]=sbnf[3]; nf[4]=(long)det(m);
  nf[5]=(long)mas; nf[6]=(long)ro; nf[7]=(long)bas; nf[8]=(long)m; nf[9]=(long)mul;
  funits=(GEN)sbnf[11]; ru=lg(funits);
  v1=cgetg(ru,t_VEC); for (k=1; k<ru; k++) v1[k]=(long)gmul(bas,(GEN)funits[k]);
  mun=cgetg(ru,t_MAT);
  for (k=1; k<ru; k++)
  {
    p1=cgetg(r1+r2+1,t_COL); mun[k]=(long)p1;
    for (j=1; j<=r1+r2; j++)
      p1[j]=(j<=r1)?(long)glog(gsubst((GEN)v1[k],v,(GEN)ro[j]),DEFAULTPREC):(long)gmul2n(glog(gsubst((GEN)v1[k],v,(GEN)ro[j]),DEFAULTPREC),1);
  }
  pfc=(GEN)sbnf[9]; lpf=lg(pfc); vp=cgetg(lpf,t_COL);
  for (j=1; j<lpf; j++) vp[j]=lstoi(j);
  pfb=cgetg(lpf,t_COL);
  for (k=1; k<lpf; k++) pfb[k]=(long)decodeprime(nf,(GEN)pfc[k]);
  alphs=(GEN)sbnf[12]; la=lg(alphs); v2=cgetg(la,t_VEC);
  for (k=1; k<la; k++) v2[k]=(long)gmul(bas,(GEN)alphs[k]);
  v3=cgetg(la,t_VEC); wprec=gprecision(ro); if (wprec<DEFAULTPREC) wprec=DEFAULTPREC;
  for (k=1; k<la; k++) v3[k]=(long)gdivgs(glog(gabs(gnorm(gmodulcp((GEN)v2[k],pol)),wprec),wprec),n);
  mc=cgetg(la,t_MAT);
  for (k=1; k<la; k++)
  {
    p1=cgetg(r1+r2+1,t_COL); mc[k]=(long)p1;
    for (j=1; j<=r1+r2; j++)
      p1[j]=(j<=r1)?(long)gsub(glog(gsubst((GEN)v2[k],v,(GEN)ro[j]),wprec),(GEN)v3[k]):(long)gmul2n(gsub(glog(gsubst((GEN)v2[k],v,(GEN)ro[j]),wprec),(GEN)v3[k]),1);
  }
  clgg=classintern(nf,(GEN)sbnf[7],pfb); racu=(GEN)sbnf[10];
  res=cgetg(7,t_VEC); p1=cgetg(4,t_VEC); res[1]=(long)p1;
  p1[1]=clgg[1]; p1[2]=clgg[2]; p1[3]=clgg[3];
  p1=gtrans(greal(mun)); vla=lg(p1);
  if (vla>1)
  {
    setlg(p1,vla-1); p2=det(p1); setlg(p1,vla); res[2]=(long)gabs(p2,wprec);
  }
  else res[2]=un;
  res[3]=(long)dbltor(1.0); p1=cgetg(3,t_VEC); res[4]=(long)p1;
  p1[1]=racu[1]; p1[2]=(long)gmul(bas,(GEN)racu[2]);
  res[5]=(long)v1; res[6]=lstoi(1000);
  if (lg(sbnf[7])>1) { mit=(GEN)sbnf[7]; mata=(GEN)sbnf[8]; }
  else
  { mit=cgetg(1,t_MAT); mata=cgetg(la,t_MAT); for (k=1; k<la; k++) mata[k]=lgetg(1,t_COL); }
  tetpil=avma; y=cgetg(11,t_VEC); y[1]=lcopy(mit); y[2]=lcopy(mata);
  y[3]=lcopy(mun); y[4]=lcopy(mc); y[5]=lcopy(pfb); y[6]=lcopy(vp);
  y[7]=lcopy(nf); y[8]=lcopy(res); p1=cgetg(4,t_VEC); y[9]=(long)p1;
  p1[1]=lcopy((GEN)clgg[4]); p1[2]=lcopy((GEN)clgg[5]); p1[3]=lcopy((GEN)clgg[6]);
  y[10]=zero;
  return gerepile(av,tetpil,y);
}

static GEN
classgroupall(GEN P, GEN data, long flag, long flall, long prec)
{
  long lx=lg(data),nbrelpid,minsfb,flun,av;
  GEN gcbach,gcbach2,gRELSUP,gborne,p1;
  long court[3],doub[4];

  av=avma;
  if (gcmp0(data)) lx=1;
  else if (typ(data)!=t_VEC) err(talker,"incorrect parameters in classgroup");
  court[0]=evaltyp(t_INT) | evalpere(1) | evallg(3);
  affsi(5,court);
  doub[0]=evaltyp(t_REAL) | evalpere(1) | evallg(4);
  av=avma; p1=dbltor(0.3); affrr(p1,doub); avma=av;
  gcbach=(lx>1)?(GEN)data[1]:doub;
  gcbach2=(lx>2)?(GEN)data[2]:doub;
  gRELSUP=(lx>3)?(GEN)data[3]:court;
  gborne=(lx>4)?(GEN)data[4]:gun;
  nbrelpid=(lx>5)?itos((GEN)data[5]):4;
  minsfb=(lx>6)?itos((GEN)data[6]):3;
  if (!flall) flag+=4;
  switch(flag)
  {
    case 0: flun=-2; break;
    case 1: flun=-3; break;
    case 2: flun=-1; break;
    case 3: 
     return smallbuchinit(P,gcbach,gcbach2,gRELSUP,gborne,nbrelpid,minsfb,prec);
    case 4: flun=2; break;
    case 5: flun=3; break;
    case 6: flun=0; break;
    default: err(flagerr); return NULL; /* not reached */
  }
  return buchall(P,gcbach,gcbach2,gRELSUP,gborne,nbrelpid,minsfb,flun,prec);
}

GEN
classgroup0(GEN P, long flag, GEN data, long prec)
{
  if (typ(P)==t_INT) return quadclassunit0(P,0,data,prec);
  return classgroupall(P,data,flag,0,prec);
}

GEN
bnfinit0(GEN P, long flag, GEN data, long prec)
{
  if (typ(P)==t_INT)
  {
    if (flag<4) err(impl,"specific bnfinit for quadratic fields");
    return quadclassunit0(P,0,data,prec);
  }
  return classgroupall(P,data,flag,1,prec);
}

GEN
classgrouponly(GEN P, GEN data, long prec)
{
  GEN y,z;
  long av=avma,tetpil,i;

  if (typ(P)==t_INT)
  {
    z=quadclassunit0(P,0,data,prec); tetpil=avma;
    y=cgetg(4,t_VEC); for (i=1; i<=3; i++) y[i]=lcopy((GEN)z[i]);
    return gerepile(av,tetpil,y);
  }
  z=(GEN)classgroupall(P,data,2,0,prec)[1]; tetpil=avma;
  return gerepile(av,tetpil,gcopy((GEN)z[5]));
}

GEN
regulator(GEN P, GEN data, long prec)
{
  GEN z;
  long av=avma,tetpil;

  if (typ(P)==t_INT)
  {
    if (signe(P)>0)
    {
      z=quadclassunit0(P,0,data,prec); tetpil=avma;
      return gerepile(av,tetpil,gcopy((GEN)z[4]));
    }
    return gun;
  }
  z=(GEN)classgroupall(P,data,2,0,prec)[1]; tetpil=avma;
  return gerepile(av,tetpil,gcopy((GEN)z[6]));
}
