#include "genpari.h"
uLong overflow,hiremainder;

/* Don't know why some of these are `inline' [Ptitboul] */
/* However, it does not work. */
#undef INLINE
#define INLINE

INLINE long
addll(uLong x, uLong y)
{
  uLong z;

  z=x+y;overflow=(z<x)?1:0; return z;
}

INLINE long
addllx(uLong x, uLong y)
{
  uLong z;

  z=x+y+overflow;overflow=(z<x)||((z==x)&&overflow)?1:0; return z;
}

INLINE long
subll(uLong x, uLong y)
{
  uLong z;

  z=x-y;overflow=(z>x)?1:0; return z;
}

INLINE long
subllx(uLong x, uLong y)
{
  uLong z;

  z=x-y-overflow;overflow=(z>x)||((z==x)&&overflow)?1:0; return z;
}

INLINE long
shiftl(uLong x, uLong y)
{
  hiremainder=x>>(32-y);return (x<<y);
}

INLINE long
shiftlr(uLong x, uLong y)
{
  hiremainder=x<<(32-y);return (x>>y);
}

INLINE long
mulll(uLong x, uLong y)
{
  uLong xlo,xhi,ylo,yhi;
  uLong z;

  xlo=x&65535;xhi=x>>16;ylo=y&65535;yhi=y>>16;
  z=addll(xlo*yhi,xhi*ylo);
  hiremainder=(overflow)?xhi*yhi+65536+(z>>16):xhi*yhi+(z>>16);
  z=addll(xlo*ylo,(z<<16));hiremainder+=overflow;
  return z;
}

INLINE long
addmul(uLong x, uLong y)
{
  uLong xlo,xhi,ylo,yhi;
  uLong z,z2;

  xlo=x&65535;xhi=x>>16;ylo=y&65535;yhi=y>>16;
  z=addll(xlo*yhi,xhi*ylo);
  z2=(overflow)?xhi*yhi+65536+(z>>16):xhi*yhi+(z>>16);
  z=addll(xlo*ylo,(z<<16));z2+=overflow;
  z=addll(z,hiremainder);hiremainder=z2+overflow;
  return z;
}

int
bfffo(uLong x)
{
  int sc;
  static int tabshi[16]={4,3,2,2,1,1,1,1,0,0,0,0,0,0,0,0};

  if(x&(0xffff0000)) sc=0;else {sc=16;x<<=16;}
  if(!(x&(0xff000000))) {sc+=8;x<<=8;}
  if(x&(0xf0000000)) x>>=28;else {sc+=4;x>>=24;}
  sc+=tabshi[x];return sc;
}

long
divll(uLong x, uLong y)
{
#define GLUE(hi, lo) ((hi << 16) + lo)
#define SPLIT(a, b, c) b = HIGHWORD(a); c = LOWWORD(a)

  uLong v1, v2, u3, u4, q1, q2, aux, aux1, aux2;
  int k;
    
  for(k = 0; !(y & HIGHBIT); k++)
  {
    hiremainder <<= 1;
    if (x & HIGHBIT) hiremainder++;
    x <<= 1;
    y <<= 1;
  }
        
  SPLIT(y, v1, v2);
  SPLIT(x, u3, u4);
    
  q1 = hiremainder / v1; if (q1 & HIGHMASK) q1 = LOWMASK;
  hiremainder -= q1 * v1;
  aux = v2 * q1;
  again:
  SPLIT(aux, aux1, aux2);
  if (aux2 > u3) aux1++;
  if (aux1 > hiremainder) {q1--; hiremainder += v1; aux -= v2; goto again;}
  u3 -= aux2;
  hiremainder -= aux1;
  hiremainder <<= 16; hiremainder += u3 & LOWMASK;
    
  q2 = hiremainder / v1; if (q2 & HIGHMASK) q2 = LOWMASK;
  hiremainder -= q2 * v1;
  aux = v2 * q2;
  again2:
  SPLIT(aux, aux1, aux2);
  if (aux2 > u4) aux1++;
  if (aux1 > hiremainder) {q2--; hiremainder += v1; aux -= v2; goto again2;}
  u4 -= aux2;
  hiremainder -= aux1;
  hiremainder <<= 16; hiremainder += u4 & LOWMASK;
  hiremainder >>= k;
  return GLUE(q1, q2);
}

double
rtodbl(GEN x)
{
  double y,ma,co=32.0;
  long ex,s=signe(x);
  
  if((!s)||((ex=expo(x))< -1023)) return 0.0;
  if(ex>=0x3ff) err(rtodber);
  ma=(uLong)x[2]+(uLong)x[3]/exp2(co);
  y=exp2(ex+1-co);
  return (s<0) ? -y*ma : y*ma;
}

GEN
dbltor(double x)
{
  GEN z;
  double co=32.0;
  uLong y;
  long ex;
  int n;
  
  if(x==0) {z=cgetr(3);z[2]=0;z[1]=0x800000-308;return z;}
  z=cgetr(4);if(x<0) {setsigne(z,-1);x= -x;} else setsigne(z,1);
  ex=(long)floor(log2(x));setexpo(z,ex);x=x*exp2(-ex+co-1);y=(uLong)x;x-=y;z[2]=y;
  y=(long)(exp2(co)*x);z[3]=y;

  if(!(z[2]&(1<<31)))
  {
    n=bfffo(z[2]);z[2]=shiftl(z[2],n);z[3]=shiftl(z[3],n);
    z[2]+=hiremainder;setexpo(z,expo(z)-n);
  }
  return z;
}

double
gtodouble(GEN x)
{
  GEN     x1;
  static long reel4[4]={0x2010004,0,0,0};
  
  if (typ(x)==t_REAL) x1=x; else gaffect(x,x1=(GEN)reel4);
  return rtodbl(x1);
}
